#ifndef lint
static char yysccsid[] = "@(#)yaccpar 1.8 (Berkeley) 01/20/91";
#endif
#define YYBYACC 1
#line 33 "parser.y"
#include "../compat/std-c.h"

#include "mindycomp.h"
#include "header.h"
#include "parser.h"
#include "lexer.h"
#include "feature.h"
#include "literal.h"
#include "src.h"
#include "sym.h"

struct token_list {
    int token;
    struct token_list *next;
} *yacc_recovery_list = NULL;

static void yyerror(char *);
static boolean verify_symbol_aux(struct id *id, struct token *against);
static void yacc_recover();
static void push_yacc_recovery(int token);
static void pop_yacc_recoveries(int count);

#define verify_symbol(id,sym) if (verify_symbol_aux(id,sym)) YYERROR

#line 59 "parser.y"
typedef union {
    struct _nothing *nothing;
    struct token *token;
    struct body *body;
    struct constituent *constituent;
    struct expr *expr;
    struct bindings *bindings;
    struct param_list *param_list;
    struct param *param;
    struct keyword_param *keyword_param;
    struct id *id;
    struct local_methods *local_methods;
    struct method *method;
    struct binop_series *binop_series;
    struct binop *binop;
    struct literal *literal;
    struct arglist *arglist;
    struct argument *argument;
    struct plist *plist;
    struct return_type_list *return_type_list;
    struct literal_list *literal_list;
    struct block_epilog *block_epilog;
    struct condition_body *condition_body;
    struct incomplete_condition_body *incomplete_condition_body;
    struct condition_clause *condition_clause;
    struct for_header *for_header;
    struct exception_clauses *exception_clauses;
    struct exception_clause *exception_clause;
    struct for_clause *for_clause;
    struct to_part *to_part;
    struct superclass_list *superclass_list;
    struct class_guts *class_guts;
    struct slot_spec *slot_spec;
    struct initarg_spec *initarg_spec;
    boolean bool;
    struct inherited_spec *inherited_spec;
    enum slot_allocation slot_allocation;
    struct gf_suffix *gf_suffix;
    flags_t flags;
    struct else_part *else_part;

    struct defnamespace_constituent *defnamespace_constituent;
    struct variable_names *variable_names;
    struct use_clause *use_clause;
    struct use_options *use_options;
    struct use_option *use_option;
    struct import_option *import_option;
    struct renamings *renamings;
} YYSTYPE;
#line 81 "parser-tab.tab.c"
#define HEADER_KEY 257
#define HEADER_VAL 258
#define HEADER_END 259
#define BOGUS 260
#define SYMBOL 261
#define KEYWORD 262
#define SYMBOL_LITERAL 263
#define SHARP_T 264
#define SHARP_F 265
#define STRING 266
#define CHARACTER 267
#define INTEGER 268
#define FLOAT 269
#define BINARY_OPERATOR 270
#define LPAREN 271
#define RPAREN 272
#define COMMA 273
#define DOT 274
#define SEMI 275
#define LBRACKET 276
#define RBRACKET 277
#define LBRACE 278
#define RBRACE 279
#define COLON_COLON 280
#define MINUS 281
#define TILDE 282
#define EQUAL 283
#define EQUAL_EQUAL 284
#define ARROW 285
#define SHARP_PAREN 286
#define SHARP_BRACKET 287
#define NEXT 288
#define REST 289
#define KEY 290
#define ALL_KEYS 291
#define ABOVE 292
#define ABSTRACT 293
#define DBEGIN 294
#define BELOW 295
#define BLOCK 296
#define BY 297
#define CASE 298
#define CLASS 299
#define CLEANUP 300
#define CONCRETE 301
#define CONSTANT 302
#define DEFINE 303
#define DOMAIN 304
#define EACH_SUBCLASS 305
#define ELSE 306
#define ELSEIF 307
#define END 308
#define EXCEPTION 309
#define FINALLY 310
#define FOR 311
#define FREE 312
#define FROM 313
#define FUNCTION 314
#define GENERIC 315
#define HANDLER 316
#define IF 317
#define IN 318
#define INHERITED 319
#define INLINE 320
#define INSTANCE 321
#define KEYED_BY 322
#define KEYWORD_RESERVED_WORD 323
#define LET 324
#define LOCAL 325
#define METHOD 326
#define OPEN 327
#define OTHERWISE 328
#define PRIMARY 329
#define REQUIRED 330
#define SEALED 331
#define SELECT 332
#define SLOT 333
#define THEN 334
#define TO 335
#define UNLESS 336
#define UNTIL 337
#define USING 338
#define VARIABLE 339
#define VIRTUAL 340
#define WHILE 341
#define MODULE 342
#define LIBRARY 343
#define EXPORT 344
#define CREATE 345
#define USE 346
#define ALL 347
#define PREFIX_KEYWORD 348
#define IMPORT_KEYWORD 349
#define EXCLUDE_KEYWORD 350
#define EXPORT_KEYWORD 351
#define RENAME_KEYWORD 352
#define UNTIL_KEYWORD 353
#define WHILE_KEYWORD 354
#define FEATURE_IF 355
#define FEATURE_ELSE_IF 356
#define FEATURE_ELSE 357
#define FEATURE_ENDIF 358
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    1,    1,    2,    2,  138,    3,   18,   19,   19,
   20,   20,   24,   24,   24,   24,   25,   25,   25,   25,
   25,   25,   25,   25,   25,  109,  109,  109,  109,  109,
  109,  109,  109,   26,   26,   26,   26,   30,   30,   35,
   35,   35,   49,   49,   31,   31,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   55,   55,
   56,  136,  136,  136,  136,  136,  136,  136,  136,   61,
   61,   61,   72,   72,   73,   73,   73,   73,   62,   62,
   62,   63,   63,   63,   63,   63,   63,   63,   63,   74,
   74,   75,   75,   76,   76,   82,   82,   82,   82,   82,
   82,   82,   82,   82,   82,   83,   83,   85,   86,   86,
   87,   87,   84,   84,  139,   64,  140,   64,  141,   64,
  142,   64,  143,   64,  144,   64,  145,   64,  146,   64,
  147,   64,   89,   89,   88,   88,   90,   92,   92,   92,
   92,   92,   92,   93,   93,   94,   94,   95,   95,   95,
   91,   91,   91,   91,   96,   96,   96,   97,   97,   98,
   98,   98,   98,   98,   98,   98,   65,   21,   22,  111,
  111,   99,   99,   99,   99,   27,  100,  100,  101,  101,
  102,  102,  102,  102,  102,  102,  103,  110,  110,  110,
   70,   70,   67,   67,  104,  105,  105,  106,  107,  107,
  107,  107,  107,   77,   77,   78,   78,   28,   29,  108,
  108,  108,   36,   36,   36,   37,   37,   37,   38,   38,
   38,   39,   40,   40,   40,   41,   41,   41,   52,   52,
   57,   60,   60,   58,   59,   59,   59,   79,   79,   80,
   80,   80,   80,   81,   81,   68,   68,   42,   42,   42,
   43,   43,   43,   50,   50,   50,   44,   44,   44,   53,
   45,   45,   45,   54,   46,   47,   47,   47,   48,   48,
   48,   51,   51,  137,  137,   69,   69,   71,   71,  113,
  119,  119,  115,  115,  115,  116,  116,  116,  116,  116,
  116,  121,  122,  123,  124,  124,  125,  125,  125,  125,
  125,  126,  130,  130,  133,  133,  132,  132,  132,  132,
  127,  129,  129,  128,  128,  131,  131,  134,  134,  135,
  135,  114,  120,  120,  117,  117,  117,  118,  118,  118,
  118,    4,    4,    5,    5,    6,    6,    7,    7,    8,
    8,    9,    9,   10,   10,   11,   11,   12,   12,   13,
   13,   14,   14,   15,   15,   16,   16,   17,   17,   32,
   32,   34,   34,   66,   66,  112,  112,   23,   23,
};
short yylen[] = {                                         2,
    2,    1,    2,    2,    3,    0,    2,    2,    0,    1,
    1,    3,    1,    1,    1,    1,    4,    3,    4,    4,
    4,    4,    3,    3,    3,    0,    2,    2,    2,    2,
    2,    2,    2,    2,    5,    8,    2,    3,    5,    1,
    1,    3,    1,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    3,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    3,    1,    1,    1,    1,    2,    2,
    1,    1,    1,    4,    4,    1,    3,    3,    1,    0,
    1,    1,    3,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    3,    3,    3,    1,    2,    3,    0,    1,
    1,    3,    1,    1,    0,    4,    0,    9,    0,    5,
    0,    9,    0,    9,    0,    9,    0,    8,    0,    8,
    0,    8,    0,    1,    3,    1,    1,    2,    2,    2,
    2,    1,    3,    0,    1,    1,    2,    3,    6,    8,
    3,    2,    3,    3,    2,    3,    3,    3,    3,    5,
    7,    3,    5,    5,    7,    5,    2,    2,    2,    2,
    6,    0,    2,    2,    2,    8,    1,    3,    0,    2,
    1,    1,    1,    3,    3,    3,    7,    0,    2,    2,
    0,    2,    0,    2,    4,    1,    0,    5,    0,    1,
    1,    1,    1,    0,    1,    3,    4,    4,    5,    1,
    3,    5,    0,    2,    1,    0,    3,    2,    1,    3,
    1,    2,    0,    2,    1,    1,    3,    3,    3,    2,
    4,    5,    5,    5,    5,    4,    5,    3,    5,    0,
    2,    1,    4,    1,    3,    1,    3,    0,    2,    1,
    0,    3,    2,    1,    3,    3,    1,    3,    1,    2,
    1,    3,    1,    2,    2,    0,    2,    1,    1,    3,
    3,    4,    5,    0,    1,    0,    2,    0,    2,    5,
    0,    1,    0,    1,    2,    1,    1,    1,    3,    3,
    3,    2,    2,    3,    0,    3,    1,    1,    1,    1,
    1,    2,    2,    4,    0,    1,    1,    3,    3,    5,
    2,    2,    2,    3,    4,    3,    5,    2,    3,    1,
    3,    5,    0,    1,    0,    1,    2,    1,    1,    3,
    3,    0,    1,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,    0,    1,    0,    1,    0,    1,
};
short yydefred[] = {                                      0,
    0,    2,    0,    6,    0,    4,    1,    0,    0,    3,
   16,   47,   82,  122,  116,  117,  126,  119,  120,  121,
    0,    0,    0,    0,    0,   48,   49,  135,    0,   50,
  139,   51,   52,   53,    0,   54,   55,    0,   56,   57,
   46,    0,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,   66,    0,   67,   68,   69,    0,    0,
   70,   71,   72,    0,   73,   74,   75,   76,   77,   78,
   83,   84,   85,   86,   87,   88,   89,    7,    0,   11,
   13,   14,  103,   45,  106,   15,    0,    0,  109,  102,
    0,   90,    5,    0,   99,  100,  133,  131,    0,    0,
    0,  134,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   34,    0,    0,  373,
    0,    0,   79,    0,    0,    0,    0,    0,    0,    0,
    8,   95,   96,   97,   98,    0,    0,    0,    0,    0,
  127,  108,  123,  124,    0,    0,  125,   10,    0,  381,
    0,    0,    0,    0,  157,    0,   18,   23,    0,   24,
    0,   25,   29,    0,   30,    0,   32,    0,    0,   33,
    0,   28,   31,   27,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   40,    0,    0,    0,
    0,    0,   81,    0,    0,    0,    0,    0,  270,  279,
  283,    0,    0,    0,    0,    0,    0,    0,    0,   12,
    0,   93,  114,    0,    0,  112,    0,  107,    0,  132,
  128,  136,  137,  377,    0,    0,    0,    0,    0,  172,
    0,    0,    0,    0,    0,  307,  308,  306,    0,    0,
  349,  348,   17,    0,   19,    0,    0,   21,   20,    0,
   22,    0,  158,  160,  159,  161,    0,    0,    0,    0,
  143,    0,  141,  284,    0,    0,    0,    0,   44,   38,
    0,   80,  280,    0,  285,  288,    0,  295,    0,    0,
    0,    0,    0,  269,    0,    0,  251,    0,  385,    0,
  147,  149,  151,   94,  105,    0,  115,  104,    0,  171,
  179,  178,  355,  140,    0,    0,  173,  174,  340,    0,
    0,  315,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  163,    0,    0,   42,
    0,    0,    0,   35,    0,  287,    0,    0,  275,  276,
  375,    0,    0,    0,  273,    0,  278,  282,  187,  145,
    0,    0,    0,  113,    0,    0,  175,    0,    0,  302,
    0,  310,  311,  309,  344,    0,  351,  350,  197,    0,
    0,    0,    0,    0,  235,  241,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   39,    0,
    0,    0,    0,  290,  291,    0,    0,    0,    0,    0,
    0,  264,    0,    0,  257,  255,  272,    0,    0,    0,
    0,    0,  154,    0,    0,    0,  166,  176,  177,  341,
    0,  379,  300,  342,    0,    0,  228,    0,    0,    0,
    0,  242,  245,    0,    0,    0,    0,  234,    0,    0,
  180,  194,  195,  193,  186,  184,    0,    0,  389,    0,
    0,    0,  387,    0,  226,    0,    0,  254,    0,  297,
    0,  292,    0,  261,    0,  258,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  167,    0,    0,    0,
    0,    0,  316,  317,  319,  320,  321,  318,    0,  216,
    0,    0,  201,  202,    0,  203,    0,    0,  198,  252,
  383,  253,  244,  250,    0,    0,    0,  230,  229,  238,
    0,  240,    0,    0,  189,    0,  190,    0,    0,   36,
  227,  293,  299,    0,  267,    0,  265,    0,  363,  148,
  365,  150,  367,  152,    0,    0,  168,  353,  138,  188,
  155,    0,  322,    0,  323,    0,  331,  332,  333,    0,
    0,    0,    0,  200,    0,  210,    0,  221,  222,  220,
  223,    0,  247,  248,  249,    0,    0,  237,  181,  185,
  359,  144,    0,  357,  142,  259,  263,  361,  146,    0,
    0,    0,    0,    0,  338,    0,  334,    0,    0,    0,
  369,    0,  204,  205,  206,    0,    0,    0,  231,    0,
    0,    0,    0,    0,  324,  339,    0,    0,  335,    0,
    0,  196,  215,    0,    0,    0,    0,  169,  328,    0,
  336,    0,  212,  218,    0,    0,  232,  191,    0,    0,
    0,  214,    0,  170,  330,  337,  207,
};
short yydgoto[] = {                                       3,
    4,    5,    7,  539,  304,  575,  572,  579,  530,  532,
  534,  592,  429,  121,  131,  225,  423,  148,  149,   79,
  476,  449,  450,   80,   81,   82,  243,  245,  249,  117,
   83,  151,   84,  502,  185,  374,  438,  375,  376,  432,
  433,  198,  284,  199,  200,  201,  275,  276,  119,  202,
  277,  434,  203,  187,  122,  123,   85,  193,  125,  248,
   86,   87,   88,   89,  289,  290,  626,  402,  398,  611,
  462,  136,  137,  214,  215,  216,  332,  333,  344,  403,
  404,   90,   91,   98,   99,  100,  101,  413,  414,  154,
  155,  181,  415,  416,  417,  308,  156,  182,  384,  370,
  491,  492,  493,  494,  495,  496,  562,  509,  497,  498,
  453,  454,  160,  162,  234,  235,  239,  240,  361,  366,
  236,  237,  238,  359,  483,  484,  485,  486,  487,  488,
  589,  583,  584,  547,  310,   92,  279,    8,  105,  299,
  107,  328,  326,  408,  351,  352,  353,
};
short yysindex[] = {                                    -27,
 -220,    0,    0,    0,  -19,    0,    0, 1491, -205,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1778, 2095, 2095, -127, -127,    0,    0,    0, -165,    0,
    0,    0,    0,    0, -241,    0,    0, -123,    0,    0,
    0,  -73,    0,    0,    0,    0,    0,    0, 2223, -260,
  -63,    0,    0,    0,  -59,    0,    0,    0,    6,   15,
    0,    0,    0,   26,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -89,    0,
    0,    0,    0,    0,    0,    0,  -25, -154,    0,    0,
   -2,    0,    0,    8,    0,    0,    0,    0,   29,   35,
 -107,    0,   47,   55, 1491, 3050, 1684, 2416, 2416, 3050,
 3050,  -44, 2001, 1778, 2479, 2544,    0,   59,   52,    0,
 3050,   69,    0, 2158,   36, 1778, 1778, 1778, 1778, 1491,
    0,    0,    0,    0,    0,  -25, 2095, 1778, 3050, 1778,
    0,    0,    0,    0, -127, -127,    0,    0,   38,    0,
   90,   66, -237,   61,    0,   99,    0,    0,  -52,    0,
  -72,    0,    0, 3050,    0, 3050,    0, 3050, 3050,    0,
 3050,    0,    0,    0, 2479, 1778, 1778, 1778, 1778, -126,
  105,  110,  118, 3050,  120,  129,    0, 1778,  111, 2095,
 1778,  -63,    0, -260, 3050,  470,  -85,  134,    0,    0,
    0,  147,  149,  151, -260,  128,  154,  160,  161,    0,
 2095,    0,    0,  163,  164,    0, 1778,    0,  159,    0,
    0,    0,    0,    0, 1491, 1778, 1491,  140, 1293,    0,
 3050, 3050, 3050,  131,  169,    0,    0,    0,  137,  172,
    0,    0,    0,  178,    0,  180,  -63,    0,    0,  184,
    0,  187,    0,    0,    0,    0, 1778, 1778, 1778, 3050,
    0, 2001,    0,    0,  177, 2479,  179, 1778,    0,    0,
  155,    0,    0,  171,    0,    0,  191,    0, 3050, 1778,
 1778, -211, 2158,    0,  -71,  185,    0, 1778,    0,  196,
    0,    0,    0,    0,    0, 1778,    0,    0, 1491,    0,
    0,    0,    0,    0,  194, -237,    0,    0,    0,  201,
  201,    0,  138,  -52,  139,  -72, 1778, 1778,  175, 2286,
  202,  150, -263,  148,  174, 1491,    0, 1491, 1778,    0,
  463,  223,  224,    0, -260,    0,  502, -177,    0,    0,
    0, 2351, 1491, 1491,    0,  147,    0,    0,    0,    0,
 1491, 1491, 1491,    0,  193, 1293,    0, 3050,  234,    0,
  235,    0,    0,    0,    0,  235,    0,    0,    0,   17,
  237,  203, 1872,  248,    0,    0,  251,  254, 1778, 1778,
 1778, 1778, 1778,  128, 3050, 1778,  211,   -7,    0, 1778,
  240,  463, 3050,    0,    0, 1778, 2095,  245, 2607, 3050,
  249,    0,  256,  263,    0,    0,    0, 1684,  236,  241,
  242, 2672,    0,  253,  257,  193,    0,    0,    0,    0,
  -39,    0,    0,    0, -273, 1778,    0,  244, 3218,  272,
  268,    0,    0,  297, 3050, -222, 2286,    0,  292,  259,
    0,    0,    0,    0,    0,    0,  246, 1491,    0,  282,
 1491,  329,    0,  293,    0, 1778, 1778,    0,  330,    0,
 1778,    0,  331,    0, 1778,    0, 2735,  302,  269,  276,
  279, 1778, 1491,  326, 1491,  193,    0,  357, -252,  349,
 -251,  352,    0,    0,    0,    0,    0,    0,  300,    0,
  327,  361,    0,    0,  314,    0, 3306, -232,    0,    0,
    0,    0,    0,    0, 1936,  268, 2800,    0,    0,    0,
  251,    0, 1778, 3050,    0,  335,    0, 1778,  328,    0,
    0,    0,    0,  372,    0, 3050,    0,  317,    0,    0,
    0,    0,    0,    0,  370,  179,    0,    0,    0,    0,
    0,  193,    0, 3050,    0, 2869,    0,    0,    0, 2938,
 3050,  355, -273,    0,  393,    0,    0,    0,    0,    0,
    0,  324,    0,    0,    0, 2607,  179,    0,    0,    0,
    0,    0,  386,    0,    0,    0,    0,    0,    0, 1778,
  392,  380,  394,  387,    0, -169,    0,  390, -128,  388,
    0,  235,    0,    0,    0,  179, 3050,  405,    0, 1491,
  179, 1491, 3050, 3050,    0,    0, 3050, 3050,    0, 1778,
  179,    0,    0,  398,  179,   -7,  412,    0,    0,  400,
    0,  401,    0,    0, 2095,  388,    0,    0, 1491, 3050,
 3050,    0,  179,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  417,  413,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3283,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3106,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   79,    0,
    0,    0,    0,    0,    0,    0,  181, 1213,    0,    0,
  652,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  419,    0,    0,  416,  402,  426,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -242,    0,    0,
    0,  373,    0,  437,    0,    0,    0,    0,    0,   91,
    0,    0,    0,    0,    0,  334,    0,  440,    0,  442,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1590,    0,    0,    0,  423,    0,    0,  439,    0,
  441,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  455,    0,    0,    0,  473,    0,    0,    0,    0,
    0,    0,    0, 3106,    0, 2994,   32,    0,    0,    0,
    0,  478,  479,  480,  721,  487,    0,    0,    0,    0,
    0,    0,    0,    0, -153,    0,  -10,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  777,  452,    0,
    0,    0,    0,    0,  454,    0,    0,    0,    0,  458,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  491,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  501,    0,    0,    0,
    0, 1392,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  423, -226,    0,    0,    0, -223,
 -215,    0,  109,  464,  121,  466,    0,  440,    0,  504,
    0,    0, -229,   43,    0, -179,    0,    0,    0,    0,
    0,    0,  353,    0,  233,    0, 3162,  -22,    0,    0,
    0,  445,  402,  471,    0,  478,    0,    0,    0,    0,
    0,  402,  402,    0, -253,  452,    0,    0, -143,    0,
  448,    0,    0,    0,    0,  448,    0,    0,    0,    0,
    0,  395,  506,    0,    0,    0,  508,  509,    0,    0,
    0,    0,    0,   45,    0,    0,  474,  476,    0,    0,
    0,    0,  204,    0,    0,    0,    0,   54,  514,    0,
   23,    0,    0,  -69,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -120,    0,    0,    0,    0,
    0,    0,    0,    0,  -92,    0,    0,  574,  461,    0,
   65,    0,    0,  515,  -26,  500,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   84,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  833,  889,
  945,    0,    0, 1001,    0,  483,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  423,    0,    0,    0,    0,    0,  459,    0,    0,
    0,    0,    0,    0,    0,   65,    0,    0,    0,    0,
  508,    0,    0,    0,    0, 1057,    0,    0, 1113,    0,
    0,    0,    0, 1392,    0,    0,    0, 1169,    0,    0,
    0,    0,    0,    0,  315,  491,    0,    0,    0,    0,
    0,  486,    0,  516,    0,    0,    0,    0,    0,    0,
    0,  308, 3273,    0,    0,    0, -243,    0,    0,    0,
    0,    0,    0,    0,    0,  514,  500,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -94,  517,    0,    0,    0,    0,    0,    0, -233,
    0,  448,    0,    0,    0, -117,    0,    0,    0,    0,
  491,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -117,    0,    0, -238,  500,  476,    0,    0,    0,  -79,
    0,    0,    0,    0,    0, -233,    0,    0,    0,    0,
    0,    0, -117,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -191, -152,    0, -356,   -8,  -74,    0,
    0,    0,    0, -122,    0,    0,    0,    0,    0,  250,
  239, -354,  359,    0, -151,    0,  286,  362,  363,    0,
  296,    0,  457,  521,  513,  539,    0,  489, -110, -266,
    0,    0,    0, -115,    0,  633,    0,  657, -164,    0,
  -15,  -21,    0,    0,    0,  446,    0, -380, -406,  205,
    0,    0,  693, -129,    0,  536, -418,    0,    0, -384,
    0,    9,    0,  267,    0,  809,  812,    0,    0,  430,
 -213,  577,  364,  365, -395,  488,  619,    0,    0,    0,
    0,    0,  295,  304,    0,  305,    0,    0,  824,    0,
    0,  247,    0,    0,    0,    0,    0,    0,    0,    0,
 -142,  546, -139,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  381, -225,  -12,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 3637
short yytable[] = {                                      78,
   95,   96,  180,  230,  186,   94,  311,  210,  204,  424,
  219,  102,  102,  287,  463,  307,  346,  508,  241,  464,
  477,  242,  266,  252,  504,  544,  546,  271,  381,   43,
   43,  382,   97,   97,  213,  226,  213,    6,  458,  211,
   43,  211,  192,  192,  213,  489,  164,  227,   15,   27,
  331,  312,   93,  377,  153,  209,  490,   27,   27,  313,
  108,  209,  507,  341,  186,  120,  558,  192,   27,  213,
   43,  383,  559,  342,  211,   43,   27,  209,  374,   43,
  506,   15,  319,   27,  312,   27,  527,   27,  560,  209,
  375,  153,  313,  396,  545,  548,  209,  109,  183,  565,
  110,  111,  397,  358,  302,  106,  305,  561,  301,  606,
  206,  207,  208,  209,  330,  212,  138,  581,  111,  139,
  343,  140,  213,  111,  213,  217,  567,  217,    9,  343,
    9,  314,  102,  102,   13,   14,   15,   16,   17,   18,
   19,   20,  418,  393,  608,  577,  477,  113,  599,  325,
  609,  180,  357,   97,   97,  186,  257,  224,   24,   25,
  253,  254,  255,  256,  314,  145,  146,  204,  269,  204,
  511,  362,  267,  367,  364,  270,  368,  613,  327,  165,
   91,  598,  617,  278,  327,  130,  258,  156,  371,  294,
  224,  259,  624,  329,  280,  260,  627,  114,  281,  329,
   26,  297,  262,  380,  378,  262,  208,  124,   26,   26,
  153,  126,  208,  306,  637,  199,  300,  184,  196,   26,
   71,   72,   73,   74,   75,   76,   77,   26,  208,    1,
  217,    2,  372,  305,   26,  612,   26,    9,   26,   10,
  208,  322,  323,  324,  132,  380,  380,  208,  163,  296,
  296,  387,  334,  380,  164,  133,  165,  134,  135,  166,
  296,   90,   90,  141,  339,  340,   90,  167,  405,  168,
  169,  231,  349,  233,  446,  170,  127,  410,  411,  142,
  213,  171,  172,  217,  173,  128,  174,  118,  425,  426,
  355,  231,  232,  233,  266,  266,  129,  266,  451,  452,
  143,  369,  213,  274,  274,  217,  144,  368,  478,  479,
  480,  481,  482,  389,  182,  182,  384,  384,  390,  388,
  586,  378,  266,  147,  278,  298,  298,  145,  266,  266,
  266,  266,  266,   92,  191,  406,  296,  296,  190,  554,
  306,  194,  409,  205,  150,  222,  118,  118,  159,  161,
  224,  118,  225,  118,  189,  183,  183,  157,  158,  192,
  435,  223,  197,  440,  441,  442,  443,  444,  228,  301,
  447,  576,   37,  229,  455,  460,  261,  218,  374,  457,
  459,  343,  262,  301,  374,  374,  374,  374,  374,  263,
  375,  265,  153,  268,  370,  343,  375,  375,  375,  375,
  375,  266,  244,  570,  246,  282,  247,  250,  301,  192,
  499,  220,  221,  118,  301,  301,  301,  301,  301,  283,
  343,  285,  264,  286,  288,  291,  343,  343,  343,  343,
  343,  292,  293,  273,  295,  298,  296,  303,  313,  515,
  520,  521,  517,  314,  315,  523,  316,  378,  317,  525,
  318,  331,   91,   91,  320,   91,  536,   91,  321,  329,
  382,  336,  335,  337,  537,   91,  540,  350,  356,  309,
  309,  312,   91,  358,  196,   91,  380,   91,  380,  360,
   91,  365,  372,  380,  379,  385,   91,   91,   91,   91,
   91,  386,  435,  372,  391,  422,  392,  569,  118,  224,
  118,  412,  573,  380,  118,  372,  421,  372,  427,  380,
  380,  380,  380,  380,   91,   91,  428,  338,   91,  436,
  448,  197,  456,  437,  372,  372,  439,  461,  465,  372,
  466,  372,  372,  372,  372,  467,  372,  372,  372,  372,
  372,  372,  372,  469,  372,  372,  372,  397,  470,  471,
  372,  372,  372,  372,  372,  372,  475,  500,  197,  372,
  474,  372,  503,  372,  601,  372,  372,  372,  368,  505,
  372,  372,  372,  371,  372,  372,  372,  372,  372,  372,
  401,  373,  368,  514,  103,  103,  103,  103,  103,  516,
  103,  616,  513,  618,  623,  103,  420,  103,  103,  518,
  519,  522,  524,  632,  529,   92,   92,  368,   92,  528,
   92,  431,  531,  368,  368,  368,  368,  368,   92,  533,
  634,  538,  543,  118,  225,   92,  546,  225,   92,  550,
   92,  150,  551,   92,  552,  553,  555,  401,  401,   92,
   92,   92,   92,   92,  574,  571,  341,   37,  578,  580,
  473,  118,  225,  591,  596,  370,  597,  600,  225,  225,
  225,  225,  225,  602,  603,  605,  604,   92,   92,  370,
  610,   92,   37,  150,  607,  197,  615,  625,   37,   37,
   37,   37,   37,  629,  630,  631,  370,  370,  129,  129,
  130,  370,  130,  370,  370,  370,  370,  380,  370,  370,
  370,  370,  370,  370,  370,  401,  370,  370,  268,    9,
  535,  110,  370,  370,  370,  370,  370,  370,  110,  260,
  372,  370,  378,  370,   13,  370,  162,  370,  370,  370,
  374,   13,  370,  370,  370,  382,  370,  370,  370,  370,
  370,  370,  274,  431,   41,  401,  303,  378,  345,  271,
  277,  281,  118,  378,  378,  378,  378,  378,  384,  375,
  382,  304,  224,   13,  401,  346,  382,  382,  382,  382,
  382,  305,  289,  347,  224,  233,  354,  243,  256,  236,
  239,  388,  582,  386,  309,  260,  246,  501,  588,  590,
  164,  219,  394,  165,  325,  326,  568,  347,  510,  224,
  564,  512,  407,  345,  401,  224,  224,  224,  224,  224,
   71,   72,   73,   74,   75,   76,   77,   71,   72,   73,
   74,   75,   76,   77,  348,  395,  272,  251,  211,  445,
  633,  354,  362,  103,  371,  614,  104,  468,  327,  541,
  542,  619,  620,  419,  301,  621,  622,  593,  371,   71,
   72,   73,   74,   75,   76,   77,  594,  595,  112,  363,
    0,  549,  628,    0,    0,  371,  371,    0,  635,  636,
  371,    0,  371,  371,  371,  371,    0,  371,  371,  371,
  371,  371,  371,  371,    0,  371,  371,    0,  364,    0,
    0,  371,  371,  371,  371,  371,  371,    0,    0,    0,
  371,    0,  371,    0,  371,    0,  371,  371,  371,    0,
    0,  371,  371,  371,    0,  371,  371,  371,  371,  371,
  371,  118,  118,  118,  118,  118,  118,  118,  118,    0,
    0,    0,  118,    0,  118,  118,  118,    0,    0,    0,
    0,    0,    0,  118,  366,    0,  118,    0,  118,    0,
    0,  118,    0,    0,    0,    0,    0,  118,  118,  118,
  118,  118,    0,    0,  118,    0,    0,    0,    0,  118,
    0,    0,    0,  118,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  118,  118,    0,    0,  118,
  372,  372,  372,  372,  372,  372,  372,  372,    0,    0,
  352,  372,    0,  372,  372,  372,    0,    0,    0,    0,
    0,    0,  372,    0,    0,  372,    0,  372,    0,    0,
  372,    0,    0,    0,    0,    0,  372,  372,  372,  372,
  372,    0,    0,  372,    0,    0,    0,    0,  372,    0,
    0,    0,  372,    0,    0,    0,  354,  354,  354,  354,
  354,  354,  354,  354,  372,  372,  358,  354,  372,  354,
  354,  354,    0,    0,    0,    0,    0,    0,  354,    0,
    0,  354,    0,  354,    0,    0,  354,    0,    0,    0,
    0,    0,  354,  354,  354,  354,  354,    0,    0,  354,
    0,    0,    0,    0,  354,    0,    0,    0,  354,    0,
    0,    0,  362,  362,  362,  362,  362,  362,  362,  362,
  354,  354,  356,  362,  354,  362,  362,  362,    0,    0,
    0,    0,    0,    0,  362,    0,    0,  362,    0,  362,
    0,    0,  362,    0,    0,    0,    0,    0,  362,  362,
  362,  362,  362,    0,    0,  362,    0,    0,    0,    0,
  362,    0,    0,    0,  362,    0,    0,    0,  364,  364,
  364,  364,  364,  364,  364,  364,  362,  362,  360,  364,
  362,  364,  364,  364,    0,    0,    0,    0,    0,    0,
  364,    0,    0,  364,    0,  364,    0,    0,  364,    0,
    0,    0,    0,    0,  364,  364,  364,  364,  364,    0,
    0,  364,    0,    0,    0,    0,  364,    0,    0,    0,
  364,    0,  101,    0,  366,  366,  366,  366,  366,  366,
  366,  366,  364,  364,    0,  366,  364,  366,  366,  366,
    0,    0,    0,    0,    0,    0,  366,    0,    0,  366,
    0,  366,    0,    0,  366,    0,    0,    0,    0,    0,
  366,  366,  366,  366,  366,    0,    0,  366,    0,    0,
    0,    0,  366,    0,    0,    0,  366,    0,    0,    0,
  352,  352,  352,  352,  352,  352,  352,  352,  366,  366,
    0,  352,  366,  352,  352,  352,    0,    0,    0,    0,
    0,    0,  352,    0,    0,  352,    0,  352,    0,    0,
  352,    0,    0,    0,    0,    0,  352,  352,  352,  352,
  352,    0,    0,  352,    0,    0,    0,    0,  352,    0,
    0,    0,  352,    0,    0,    0,  358,  358,  358,  358,
  358,  358,  358,  358,  352,  352,    0,  358,  352,  358,
  358,  358,    0,    0,    0,    0,    0,    0,  358,    0,
    0,  358,    0,  358,    0,    0,  358,    0,    0,    0,
    0,    0,  358,  358,  358,  358,  358,    0,    0,  358,
    0,    0,    0,    0,  358,    0,    0,    0,  358,    0,
    0,    0,  356,  356,  356,  356,  356,  356,  356,  356,
  358,  358,    0,  356,  358,  356,  356,  356,    0,    0,
    0,    0,    0,    0,  356,    0,    0,  356,    0,  356,
    0,    0,  356,    0,    0,    0,    0,    0,  356,  356,
  356,  356,  356,    0,    0,  356,    0,    0,    0,    0,
  356,    0,    0,    0,  356,    0,    0,    0,  360,  360,
  360,  360,  360,  360,  360,  360,  356,  356,    0,  360,
  356,  360,  360,  360,    0,    0,    0,    0,    0,    0,
  360,    0,    0,  360,    0,  360,    0,    0,  360,    0,
    0,    0,    0,    0,  360,  360,  360,  360,  360,    0,
    0,  360,  101,    0,  101,  101,  360,  101,    0,  101,
  360,    0,    0,  101,    0,  101,  101,  101,    0,    0,
    0,    0,  360,  360,  101,    0,  360,  101,    0,  101,
    0,    0,  101,    0,    0,    0,    0,    0,  101,  101,
  101,  101,  101,    0,    0,  101,    0,    0,    0,    0,
  101,    0,    0,    0,  101,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  101,  101,   11,    0,
  101,    0,    0,   12,   13,   14,   15,   16,   17,   18,
   19,   20,    0,   21,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   22,   23,    0,    0,    0,   24,   25,
    0,    0,    0,    0,   26,   27,   28,    0,   29,   30,
   31,   32,    0,   33,   34,   35,   36,   37,    0,    0,
    0,    0,    0,   38,   39,   40,   41,    0,    0,   42,
   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
  152,   53,    0,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,  374,    0,    0,
    0,    0,  374,  374,  374,  374,  374,  374,  374,  374,
  374,    0,  374,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  374,  374,    0,    0,    0,  374,  374,    0,
    0,    0,    0,  374,  374,  374,    0,  374,  374,  374,
  374,    0,  374,  374,  374,  374,  374,    0,    0,  374,
    0,    0,  374,  374,  374,  374,    0,    0,  374,  374,
  374,  374,  374,  374,  374,  374,  374,  374,  374,    0,
  374,    0,  374,  374,  374,  374,  374,  374,  374,  374,
  374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
  374,  374,  374,  374,  374,  374,   11,    0,    0,    0,
    0,   12,   13,   14,   15,   16,   17,   18,   19,   20,
    0,   21,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   22,   23,    0,    0,    0,   24,   25,    0,    0,
    0,    0,   26,   27,   28,    0,   29,   30,   31,   32,
    0,   33,   34,   35,   36,   37,    0,    0,    0,    0,
    0,   38,   39,   40,   41,    0,    0,   42,   43,   44,
   45,   46,   47,   48,   49,   50,   51,   52,    0,   53,
    0,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,  376,    0,    0,    0,    0,
  376,  376,  376,  376,  376,  376,  376,  376,  376,    0,
  376,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  376,  376,    0,    0,    0,  376,  376,    0,    0,    0,
    0,  376,  376,  376,    0,  376,  376,  376,  376,    0,
  376,  376,  376,  376,  376,    0,    0,    0,    0,    0,
  376,  376,  376,  376,    0,    0,  376,  376,  376,  376,
  376,  376,  376,  376,  376,  376,  376,    0,  376,    0,
  376,  376,  376,  376,  376,  376,  376,  376,  376,  376,
  376,  376,  376,  376,  376,  376,  376,  376,  376,  376,
  376,  376,  376,  376,   12,   13,   14,   15,   16,   17,
   18,   19,   20,    0,   21,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   22,   23,    0,    0,    0,   24,
   25,    0,    0,    0,    0,   26,   27,   28,    0,   29,
   30,   31,   32,    0,   33,   34,    0,   36,   37,    0,
    0,    0,    0,    0,   38,   39,   40,   41,    0,    0,
   42,   43,   44,   45,   46,   47,   48,    0,    0,   51,
   52,  152,   53,    0,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   12,   13,
   14,   15,   16,   17,   18,   19,   20,    0,   21,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   22,   23,
    0,    0,    0,   24,   25,    0,    0,    0,    0,   26,
   27,   28,    0,   29,   30,   31,   32,    0,   33,   34,
    0,   36,   37,    0,    0,    0,    0,    0,   38,   39,
   40,   41,    0,    0,   42,   43,   44,   45,   46,   47,
   48,    0,    0,   51,   52,    0,   53,    0,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   12,   13,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  430,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   26,   27,    0,    0,    0,   30,    0,
   32,    0,   33,   34,    0,   36,   37,    0,    0,    0,
    0,    0,    0,   39,   40,   41,    0,    0,    0,   43,
   44,   45,   46,   47,   48,    0,   12,   13,   52,    0,
   53,    0,   54,    0,   56,   57,   58,    0,    0,   61,
   62,   63,    0,   65,   66,   67,   68,   69,   70,   71,
   72,   73,   74,   75,   76,   77,  563,   26,   27,    0,
    0,    0,   30,    0,   32,    0,   33,   34,    0,   36,
   37,    0,    0,    0,    0,    0,    0,   39,   40,   41,
    0,    0,    0,   43,   44,   45,   46,   47,   48,    0,
    0,   12,   52,    0,   53,    0,   54,    0,   56,   57,
   58,  175,    0,   61,   62,   63,    0,   65,   66,   67,
   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
    0,    0,   26,   27,    0,    0,    0,   30,    0,   32,
    0,   33,   34,    0,   36,   37,    0,    0,    0,    0,
    0,    0,   39,   40,   41,    0,    0,    0,   43,   44,
   45,   46,   47,   48,    0,    0,    0,   52,    0,   53,
    0,   54,    0,   56,   57,   58,    0,  176,   61,   62,
   63,  177,   65,   66,   67,   68,   69,   70,    0,    0,
    0,    0,    0,  178,  179,   12,    0,   14,   15,   16,
   17,   18,   19,   20,    0,   21,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   22,   23,    0,    0,    0,
   24,   25,    0,    0,    0,    0,   26,   27,   28,    0,
   29,   30,   31,   32,    0,   33,   34,    0,   36,   37,
    0,    0,    0,    0,    0,   38,   39,   40,   41,    0,
    0,   42,   43,   44,   45,   46,   47,   48,   12,    0,
   51,   52,    0,   53,    0,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
   69,   70,    0,    0,    0,  195,  184,  196,    0,   26,
   27,    0,    0,    0,   30,    0,   32,    0,   33,   34,
    0,   36,   37,    0,    0,    0,    0,    0,    0,   39,
   40,   41,    0,    0,    0,   43,   44,   45,   46,   47,
   48,    0,    0,   12,   52,    0,   53,    0,   54,    0,
   56,   57,   58,  115,    0,   61,   62,   63,    0,   65,
   66,   67,   68,   69,   70,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   26,   27,    0,    0,    0,   30,
    0,   32,    0,   33,   34,    0,   36,   37,    0,    0,
    0,    0,    0,    0,   39,   40,   41,    0,  116,    0,
   43,   44,   45,   46,   47,   48,   12,    0,    0,   52,
    0,   53,    0,   54,    0,   56,   57,   58,    0,    0,
   61,   62,   63,    0,   65,   66,   67,   68,   69,   70,
    0,    0,    0,    0,  184,  373,    0,   26,   27,    0,
    0,    0,   30,    0,   32,    0,   33,   34,    0,   36,
   37,    0,    0,    0,    0,    0,    0,   39,   40,   41,
    0,    0,    0,   43,   44,   45,   46,   47,   48,    0,
    0,   12,   52,    0,   53,    0,   54,    0,   56,   57,
   58,  399,    0,   61,   62,   63,    0,   65,   66,   67,
   68,   69,   70,    0,    0,    0,    0,    0,    0,  400,
    0,    0,   26,   27,    0,    0,    0,   30,    0,   32,
    0,   33,   34,    0,   36,   37,    0,    0,    0,    0,
    0,    0,   39,   40,   41,    0,    0,    0,   43,   44,
   45,   46,   47,   48,    0,    0,   12,   52,    0,   53,
    0,   54,    0,   56,   57,   58,  115,    0,   61,   62,
   63,    0,   65,   66,   67,   68,   69,   70,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   26,   27,    0,
    0,    0,   30,    0,   32,    0,   33,   34,    0,   36,
   37,    0,    0,    0,    0,    0,    0,   39,   40,   41,
    0,    0,    0,   43,   44,   45,   46,   47,   48,   12,
    0,    0,   52,    0,   53,    0,   54,    0,   56,   57,
   58,    0,    0,   61,   62,   63,    0,   65,   66,   67,
   68,   69,   70,    0,    0,    0,    0,  184,    0,    0,
   26,   27,    0,    0,    0,   30,    0,   32,    0,   33,
   34,    0,   36,   37,    0,    0,    0,    0,    0,    0,
   39,   40,   41,    0,    0,    0,   43,   44,   45,   46,
   47,   48,    0,    0,   12,   52,    0,   53,    0,   54,
    0,   56,   57,   58,  188,    0,   61,   62,   63,    0,
   65,   66,   67,   68,   69,   70,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   26,   27,    0,    0,    0,
   30,    0,   32,    0,   33,   34,    0,   36,   37,    0,
    0,    0,    0,    0,    0,   39,   40,   41,    0,    0,
    0,   43,   44,   45,   46,   47,   48,   12,    0,    0,
   52,    0,   53,    0,   54,    0,   56,   57,   58,    0,
    0,   61,   62,   63,    0,   65,   66,   67,   68,   69,
   70,    0,    0,    0,    0,  400,    0,    0,   26,   27,
    0,    0,    0,   30,    0,   32,    0,   33,   34,    0,
   36,   37,    0,    0,    0,    0,    0,    0,   39,   40,
   41,    0,    0,    0,   43,   44,   45,   46,   47,   48,
    0,    0,   12,   52,    0,   53,    0,   54,    0,   56,
   57,   58,  472,    0,   61,   62,   63,    0,   65,   66,
   67,   68,   69,   70,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   26,   27,    0,    0,    0,   30,    0,
   32,    0,   33,   34,    0,   36,   37,    0,    0,    0,
    0,    0,    0,   39,   40,   41,    0,    0,    0,   43,
   44,   45,   46,   47,   48,   12,    0,    0,   52,    0,
   53,    0,   54,    0,   56,   57,   58,    0,    0,   61,
   62,   63,    0,   65,   66,   67,   68,   69,   70,    0,
    0,    0,    0,  526,    0,    0,   26,   27,    0,    0,
    0,   30,    0,   32,    0,   33,   34,    0,   36,   37,
    0,    0,    0,    0,    0,    0,   39,   40,   41,    0,
    0,    0,   43,   44,   45,   46,   47,   48,    0,    0,
   12,   52,    0,   53,    0,   54,    0,   56,   57,   58,
  566,    0,   61,   62,   63,    0,   65,   66,   67,   68,
   69,   70,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   26,   27,    0,    0,    0,   30,    0,   32,    0,
   33,   34,    0,   36,   37,    0,    0,    0,    0,    0,
    0,   39,   40,   41,    0,    0,    0,   43,   44,   45,
   46,   47,   48,    0,    0,    0,   52,    0,   53,   12,
   54,    0,   56,   57,   58,    0,    0,   61,   62,   63,
    0,   65,   66,   67,   68,   69,   70,  585,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   26,   27,    0,    0,    0,   30,    0,   32,    0,   33,
   34,    0,   36,   37,    0,    0,    0,    0,    0,    0,
   39,   40,   41,    0,    0,    0,   43,   44,   45,   46,
   47,   48,    0,    0,    0,   52,    0,   53,   12,   54,
    0,   56,   57,   58,    0,    0,   61,   62,   63,    0,
   65,   66,   67,   68,   69,   70,  587,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   26,
   27,    0,    0,    0,   30,    0,   32,    0,   33,   34,
    0,   36,   37,    0,    0,    0,    0,    0,    0,   39,
   40,   41,    0,    0,  294,   43,   44,   45,   46,   47,
   48,    0,    0,    0,   52,  286,   53,    0,   54,    0,
   56,   57,   58,    0,    0,   61,   62,   63,    0,   65,
   66,   67,   68,   69,   70,  294,  294,    0,    0,    0,
  294,    0,  294,    0,  294,  294,    0,  294,  294,    0,
    0,    0,    0,    0,    0,  294,  294,  294,    0,    0,
   12,  294,  294,  294,  294,  294,  294,    0,    0,    0,
  294,    0,  294,    0,  294,    0,  294,  294,  294,    0,
    0,  294,  294,  294,    0,  294,  294,  294,  294,  294,
  294,   26,   27,    0,    0,    0,   30,    0,   32,    0,
   33,   34,    0,   36,   37,    0,    0,    0,    0,    0,
    0,   39,   40,   41,    0,    0,  372,   43,   44,   45,
   46,   47,   48,    0,    0,    0,   52,    0,   53,    0,
   54,    0,   56,   57,   58,    0,    0,   61,   62,   63,
    0,   65,   66,   67,   68,   69,   70,  372,  372,    0,
    0,    0,  372,    0,  372,    0,  372,  372,    0,  372,
  372,    0,    0,    0,    0,    0,    0,  372,  372,  372,
    0,    0,  294,  372,  372,  372,  372,  372,  372,    0,
    0,    0,  372,    0,  372,    0,  372,    0,  372,  372,
  372,    0,    0,  372,  372,  372,    0,  372,  372,  372,
  372,  372,  372,  294,  294,    0,    0,    0,  294,    0,
  294,    0,  294,  294,    0,  294,  294,    0,    0,    0,
    0,    0,    0,  294,  294,  294,    0,    0,   12,  294,
  294,  294,  294,  294,  294,    0,    0,    0,  294,    0,
  294,    0,  294,    0,  294,  294,  294,    0,    0,  294,
  294,  294,    0,  294,  294,  294,  294,  294,  294,   26,
   27,    0,    0,    0,   30,    0,   32,    0,   33,   34,
    0,   36,   37,    0,    0,    0,    0,    0,    0,   39,
   40,    0,    0,    0,    0,   43,   44,   45,   46,   47,
   48,    0,    0,    0,   52,    0,   53,    0,   54,    0,
   56,   57,   58,    0,    0,   61,   62,   63,    0,   65,
   66,   67,   68,   69,   70,   26,    0,    0,    0,    0,
    0,  208,    0,   26,   26,   26,    0,  208,    0,    0,
  375,   26,    0,   26,   26,    0,   26,    0,    0,    0,
    0,    0,   26,  208,   26,  217,   26,   26,  163,   26,
    0,   26,   26,   26,    0,  208,  165,  556,   26,   26,
    0,   26,  208,   26,    0,    0,    0,  167,    0,    0,
    0,    0,    0,    0,    0,  170,    0,    0,    0,    0,
    0,    0,  172,    0,  173,    0,  557,
};
short yycheck[] = {                                       8,
   22,   23,  113,  156,  115,   21,  232,  130,  124,  366,
  140,   24,   25,  205,  399,  229,  283,  436,  161,  400,
  416,  161,    0,  175,  431,  278,  278,  192,  292,  272,
  273,  295,   24,   25,  273,  273,  275,  258,  393,  273,
  283,  275,  272,  273,  283,  319,  300,  285,  275,  293,
  273,  275,  258,  320,  308,  299,  330,  301,  302,  275,
  302,  305,  285,  275,  175,  326,  299,  297,  312,  308,
  313,  335,  305,  285,  308,  318,  320,  321,    0,  322,
  435,  308,  247,  327,  308,  329,  467,  331,  321,  333,
    0,  107,  308,  271,  347,  347,  340,  339,  114,  506,
  342,  343,  280,  273,  227,  271,  229,  340,    0,  279,
  126,  127,  128,  129,  266,  137,  271,  536,  272,  274,
    0,  276,  138,  277,  140,  138,  507,  140,  308,  282,
  310,  275,  145,  146,  262,  263,  264,  265,  266,  267,
  268,  269,  356,  335,  273,  526,  542,  271,  567,  260,
  279,  262,  305,  145,  146,  266,  283,  275,  286,  287,
  176,  177,  178,  179,  308,  273,  274,  283,  190,  285,
  437,  314,  188,  316,  314,  191,  316,  596,  273,  300,
    0,  566,  601,  196,  279,  275,  313,  308,  318,  211,
  308,  318,  611,  273,  280,  322,  615,  271,  284,  279,
  293,  217,  272,    0,  320,  275,  299,  271,  301,  302,
  226,  271,  305,  229,  633,  308,  225,  289,  290,  312,
  348,  349,  350,  351,  352,  353,  354,  320,  321,  257,
  323,  259,    0,  356,  327,  592,  329,  257,  331,  259,
  333,  257,  258,  259,  270,  272,  273,  340,  293,  272,
  273,  326,  268,  280,  299,  281,  301,  283,  284,  304,
  283,  272,  273,  266,  280,  281,  277,  312,  343,  314,
  315,  344,  288,  346,  385,  320,  271,  352,  353,  272,
  296,  326,  327,  296,  329,  271,  331,   49,  272,  273,
  299,  344,  345,  346,  272,  273,  271,  275,  306,  307,
  272,  317,  318,  272,  273,  318,  272,    0,  348,  349,
  350,  351,  352,  329,  272,  273,  272,  273,  331,  328,
  546,  437,  300,  277,  337,  272,  273,  273,  306,  307,
  308,  309,  310,    0,  283,  344,  272,  273,  280,  492,
  356,  273,  351,  308,  106,  308,  108,  109,  110,  111,
  285,  113,    0,  115,  116,  272,  273,  108,  109,  121,
  373,  272,  124,  379,  380,  381,  382,  383,  308,  261,
  386,  524,    0,  275,  390,  397,  272,  139,  300,  392,
  396,  261,  273,  275,  306,  307,  308,  309,  310,  272,
  300,  272,  408,  283,    0,  275,  306,  307,  308,  309,
  310,  273,  164,  514,  166,  272,  168,  169,  300,  171,
  426,  145,  146,  175,  306,  307,  308,  309,  310,  273,
  300,  273,  184,  273,  297,  272,  306,  307,  308,  309,
  310,  272,  272,  195,  272,  277,  273,  298,  308,  448,
  456,  457,  451,  275,  308,  461,  275,    0,  271,  465,
  271,  273,  272,  273,  271,  275,  472,  277,  272,  283,
    0,  291,  308,  273,  473,  285,  475,  272,  275,  231,
  232,  233,  292,  273,  290,  295,  273,  297,  275,  342,
  300,  343,  308,  334,  283,  338,  306,  307,  308,  309,
  310,  318,  505,  261,  272,  261,  273,  513,  260,    0,
  262,  309,  518,  300,  266,  273,  273,  275,  272,  306,
  307,  308,  309,  310,  334,  335,  314,  279,  338,  272,
  310,  283,  283,  273,  292,  293,  273,  283,  280,  297,
  275,  299,  300,  301,  302,  273,  304,  305,  306,  307,
  308,  309,  310,  308,  312,  313,  314,  280,  308,  308,
  318,  319,  320,  321,  322,  323,  300,  314,  320,  327,
  308,  329,  291,  331,  580,  333,  334,  335,  261,  273,
  338,  339,  340,    0,  342,  343,  344,  345,  346,  347,
  342,  290,  275,  338,  270,  271,  272,  273,  274,  308,
  276,  600,  334,  602,  610,  281,  358,  283,  284,  271,
  308,  272,  272,  625,  336,  272,  273,  300,  275,  308,
  277,  373,  337,  306,  307,  308,  309,  310,  285,  341,
  629,  296,  266,  385,  272,  292,  278,  275,  295,  278,
  297,  393,  333,  300,  308,  275,  323,  399,  400,  306,
  307,  308,  309,  310,  317,  311,  275,  275,  332,  280,
  412,    0,  300,  299,  262,  261,  333,  272,  306,  307,
  308,  309,  310,  272,  285,  279,  273,  334,  335,  275,
  283,  338,  300,  435,  285,  437,  272,  280,  306,  307,
  308,  309,  310,  272,  285,  285,  292,  293,  272,  277,
  272,  297,  277,  299,  300,  301,  302,  272,  304,  305,
  306,  307,  308,  309,  310,  467,  312,  313,  272,  308,
  472,  272,  318,  319,  320,  321,  322,  323,  277,  275,
    0,  327,  275,  329,  262,  331,  272,  333,  334,  335,
  308,  262,  338,  339,  340,  275,  342,  343,  344,  345,
  346,  347,  273,  505,  272,  507,  308,  300,  308,  272,
  272,  272,  514,  306,  307,  308,  309,  310,  272,  308,
  300,  308,  272,  262,  526,  308,  306,  307,  308,  309,
  310,  308,  272,  308,  275,  272,    0,  272,  308,  272,
  272,  308,  544,  308,  546,  272,  272,  429,  550,  551,
  308,  333,  291,  308,  279,  279,  511,  285,  437,  300,
  505,  439,  346,  283,  566,  306,  307,  308,  309,  310,
  348,  349,  350,  351,  352,  353,  354,  348,  349,  350,
  351,  352,  353,  354,  286,  337,  194,  171,  136,  384,
  626,  296,    0,   25,  261,  597,   25,  408,  262,  476,
  476,  603,  604,  356,  226,  607,  608,  553,  275,  348,
  349,  350,  351,  352,  353,  354,  553,  553,   35,  314,
   -1,  481,  616,   -1,   -1,  292,  293,   -1,  630,  631,
  297,   -1,  299,  300,  301,  302,   -1,  304,  305,  306,
  307,  308,  309,  310,   -1,  312,  313,   -1,    0,   -1,
   -1,  318,  319,  320,  321,  322,  323,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,  333,  334,  335,   -1,
   -1,  338,  339,  340,   -1,  342,  343,  344,  345,  346,
  347,  270,  271,  272,  273,  274,  275,  276,  277,   -1,
   -1,   -1,  281,   -1,  283,  284,  285,   -1,   -1,   -1,
   -1,   -1,   -1,  292,    0,   -1,  295,   -1,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,  307,  308,
  309,  310,   -1,   -1,  313,   -1,   -1,   -1,   -1,  318,
   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  334,  335,   -1,   -1,  338,
  270,  271,  272,  273,  274,  275,  276,  277,   -1,   -1,
    0,  281,   -1,  283,  284,  285,   -1,   -1,   -1,   -1,
   -1,   -1,  292,   -1,   -1,  295,   -1,  297,   -1,   -1,
  300,   -1,   -1,   -1,   -1,   -1,  306,  307,  308,  309,
  310,   -1,   -1,  313,   -1,   -1,   -1,   -1,  318,   -1,
   -1,   -1,  322,   -1,   -1,   -1,  270,  271,  272,  273,
  274,  275,  276,  277,  334,  335,    0,  281,  338,  283,
  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,  292,   -1,
   -1,  295,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,   -1,  306,  307,  308,  309,  310,   -1,   -1,  313,
   -1,   -1,   -1,   -1,  318,   -1,   -1,   -1,  322,   -1,
   -1,   -1,  270,  271,  272,  273,  274,  275,  276,  277,
  334,  335,    0,  281,  338,  283,  284,  285,   -1,   -1,
   -1,   -1,   -1,   -1,  292,   -1,   -1,  295,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,  307,
  308,  309,  310,   -1,   -1,  313,   -1,   -1,   -1,   -1,
  318,   -1,   -1,   -1,  322,   -1,   -1,   -1,  270,  271,
  272,  273,  274,  275,  276,  277,  334,  335,    0,  281,
  338,  283,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,
  292,   -1,   -1,  295,   -1,  297,   -1,   -1,  300,   -1,
   -1,   -1,   -1,   -1,  306,  307,  308,  309,  310,   -1,
   -1,  313,   -1,   -1,   -1,   -1,  318,   -1,   -1,   -1,
  322,   -1,    0,   -1,  270,  271,  272,  273,  274,  275,
  276,  277,  334,  335,   -1,  281,  338,  283,  284,  285,
   -1,   -1,   -1,   -1,   -1,   -1,  292,   -1,   -1,  295,
   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,
  306,  307,  308,  309,  310,   -1,   -1,  313,   -1,   -1,
   -1,   -1,  318,   -1,   -1,   -1,  322,   -1,   -1,   -1,
  270,  271,  272,  273,  274,  275,  276,  277,  334,  335,
   -1,  281,  338,  283,  284,  285,   -1,   -1,   -1,   -1,
   -1,   -1,  292,   -1,   -1,  295,   -1,  297,   -1,   -1,
  300,   -1,   -1,   -1,   -1,   -1,  306,  307,  308,  309,
  310,   -1,   -1,  313,   -1,   -1,   -1,   -1,  318,   -1,
   -1,   -1,  322,   -1,   -1,   -1,  270,  271,  272,  273,
  274,  275,  276,  277,  334,  335,   -1,  281,  338,  283,
  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,  292,   -1,
   -1,  295,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,   -1,  306,  307,  308,  309,  310,   -1,   -1,  313,
   -1,   -1,   -1,   -1,  318,   -1,   -1,   -1,  322,   -1,
   -1,   -1,  270,  271,  272,  273,  274,  275,  276,  277,
  334,  335,   -1,  281,  338,  283,  284,  285,   -1,   -1,
   -1,   -1,   -1,   -1,  292,   -1,   -1,  295,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,  307,
  308,  309,  310,   -1,   -1,  313,   -1,   -1,   -1,   -1,
  318,   -1,   -1,   -1,  322,   -1,   -1,   -1,  270,  271,
  272,  273,  274,  275,  276,  277,  334,  335,   -1,  281,
  338,  283,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,
  292,   -1,   -1,  295,   -1,  297,   -1,   -1,  300,   -1,
   -1,   -1,   -1,   -1,  306,  307,  308,  309,  310,   -1,
   -1,  313,  270,   -1,  272,  273,  318,  275,   -1,  277,
  322,   -1,   -1,  281,   -1,  283,  284,  285,   -1,   -1,
   -1,   -1,  334,  335,  292,   -1,  338,  295,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,  307,
  308,  309,  310,   -1,   -1,  313,   -1,   -1,   -1,   -1,
  318,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  334,  335,  256,   -1,
  338,   -1,   -1,  261,  262,  263,  264,  265,  266,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,  286,  287,
   -1,   -1,   -1,   -1,  292,  293,  294,   -1,  296,  297,
  298,  299,   -1,  301,  302,  303,  304,  305,   -1,   -1,
   -1,   -1,   -1,  311,  312,  313,  314,   -1,   -1,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,  331,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  256,   -1,   -1,
   -1,   -1,  261,  262,  263,  264,  265,  266,  267,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  281,  282,   -1,   -1,   -1,  286,  287,   -1,
   -1,   -1,   -1,  292,  293,  294,   -1,  296,  297,  298,
  299,   -1,  301,  302,  303,  304,  305,   -1,   -1,  308,
   -1,   -1,  311,  312,  313,  314,   -1,   -1,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,   -1,
  329,   -1,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  256,   -1,   -1,   -1,
   -1,  261,  262,  263,  264,  265,  266,  267,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  281,  282,   -1,   -1,   -1,  286,  287,   -1,   -1,
   -1,   -1,  292,  293,  294,   -1,  296,  297,  298,  299,
   -1,  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,
   -1,  311,  312,  313,  314,   -1,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,   -1,  329,
   -1,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  256,   -1,   -1,   -1,   -1,
  261,  262,  263,  264,  265,  266,  267,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,
   -1,  292,  293,  294,   -1,  296,  297,  298,  299,   -1,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
  311,  312,  313,  314,   -1,   -1,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,   -1,  329,   -1,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  261,  262,  263,  264,  265,  266,
  267,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,  286,
  287,   -1,   -1,   -1,   -1,  292,  293,  294,   -1,  296,
  297,  298,  299,   -1,  301,  302,   -1,  304,  305,   -1,
   -1,   -1,   -1,   -1,  311,  312,  313,  314,   -1,   -1,
  317,  318,  319,  320,  321,  322,  323,   -1,   -1,  326,
  327,  328,  329,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  261,  262,
  263,  264,  265,  266,  267,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,   -1,  292,
  293,  294,   -1,  296,  297,  298,  299,   -1,  301,  302,
   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,  311,  312,
  313,  314,   -1,   -1,  317,  318,  319,  320,  321,  322,
  323,   -1,   -1,  326,  327,   -1,  329,   -1,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  273,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,
  299,   -1,  301,  302,   -1,  304,  305,   -1,   -1,   -1,
   -1,   -1,   -1,  312,  313,  314,   -1,   -1,   -1,  318,
  319,  320,  321,  322,  323,   -1,  261,  262,  327,   -1,
  329,   -1,  331,   -1,  333,  334,  335,   -1,   -1,  338,
  339,  340,   -1,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  291,  292,  293,   -1,
   -1,   -1,  297,   -1,  299,   -1,  301,  302,   -1,  304,
  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,
   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,   -1,
   -1,  261,  327,   -1,  329,   -1,  331,   -1,  333,  334,
  335,  271,   -1,  338,  339,  340,   -1,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,  299,
   -1,  301,  302,   -1,  304,  305,   -1,   -1,   -1,   -1,
   -1,   -1,  312,  313,  314,   -1,   -1,   -1,  318,  319,
  320,  321,  322,  323,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,  333,  334,  335,   -1,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,   -1,   -1,
   -1,   -1,   -1,  353,  354,  261,   -1,  263,  264,  265,
  266,  267,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,
  286,  287,   -1,   -1,   -1,   -1,  292,  293,  294,   -1,
  296,  297,  298,  299,   -1,  301,  302,   -1,  304,  305,
   -1,   -1,   -1,   -1,   -1,  311,  312,  313,  314,   -1,
   -1,  317,  318,  319,  320,  321,  322,  323,  261,   -1,
  326,  327,   -1,  329,   -1,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,   -1,   -1,   -1,  288,  289,  290,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,
   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,
  313,  314,   -1,   -1,   -1,  318,  319,  320,  321,  322,
  323,   -1,   -1,  261,  327,   -1,  329,   -1,  331,   -1,
  333,  334,  335,  271,   -1,  338,  339,  340,   -1,  342,
  343,  344,  345,  346,  347,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,  299,   -1,  301,  302,   -1,  304,  305,   -1,   -1,
   -1,   -1,   -1,   -1,  312,  313,  314,   -1,  316,   -1,
  318,  319,  320,  321,  322,  323,  261,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,  333,  334,  335,   -1,   -1,
  338,  339,  340,   -1,  342,  343,  344,  345,  346,  347,
   -1,   -1,   -1,   -1,  289,  290,   -1,  292,  293,   -1,
   -1,   -1,  297,   -1,  299,   -1,  301,  302,   -1,  304,
  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,
   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,   -1,
   -1,  261,  327,   -1,  329,   -1,  331,   -1,  333,  334,
  335,  271,   -1,  338,  339,  340,   -1,  342,  343,  344,
  345,  346,  347,   -1,   -1,   -1,   -1,   -1,   -1,  289,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,  299,
   -1,  301,  302,   -1,  304,  305,   -1,   -1,   -1,   -1,
   -1,   -1,  312,  313,  314,   -1,   -1,   -1,  318,  319,
  320,  321,  322,  323,   -1,   -1,  261,  327,   -1,  329,
   -1,  331,   -1,  333,  334,  335,  271,   -1,  338,  339,
  340,   -1,  342,  343,  344,  345,  346,  347,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   -1,  297,   -1,  299,   -1,  301,  302,   -1,  304,
  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,
   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,  261,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,  333,  334,
  335,   -1,   -1,  338,  339,  340,   -1,  342,  343,  344,
  345,  346,  347,   -1,   -1,   -1,   -1,  289,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,
  302,   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,
  312,  313,  314,   -1,   -1,   -1,  318,  319,  320,  321,
  322,  323,   -1,   -1,  261,  327,   -1,  329,   -1,  331,
   -1,  333,  334,  335,  271,   -1,  338,  339,  340,   -1,
  342,  343,  344,  345,  346,  347,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
  297,   -1,  299,   -1,  301,  302,   -1,  304,  305,   -1,
   -1,   -1,   -1,   -1,   -1,  312,  313,  314,   -1,   -1,
   -1,  318,  319,  320,  321,  322,  323,  261,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,  333,  334,  335,   -1,
   -1,  338,  339,  340,   -1,  342,  343,  344,  345,  346,
  347,   -1,   -1,   -1,   -1,  289,   -1,   -1,  292,  293,
   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,   -1,
  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,  313,
  314,   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,
   -1,   -1,  261,  327,   -1,  329,   -1,  331,   -1,  333,
  334,  335,  271,   -1,  338,  339,  340,   -1,  342,  343,
  344,  345,  346,  347,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,
  299,   -1,  301,  302,   -1,  304,  305,   -1,   -1,   -1,
   -1,   -1,   -1,  312,  313,  314,   -1,   -1,   -1,  318,
  319,  320,  321,  322,  323,  261,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,  333,  334,  335,   -1,   -1,  338,
  339,  340,   -1,  342,  343,  344,  345,  346,  347,   -1,
   -1,   -1,   -1,  289,   -1,   -1,  292,  293,   -1,   -1,
   -1,  297,   -1,  299,   -1,  301,  302,   -1,  304,  305,
   -1,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,   -1,
   -1,   -1,  318,  319,  320,  321,  322,  323,   -1,   -1,
  261,  327,   -1,  329,   -1,  331,   -1,  333,  334,  335,
  271,   -1,  338,  339,  340,   -1,  342,  343,  344,  345,
  346,  347,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,  297,   -1,  299,   -1,
  301,  302,   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,  312,  313,  314,   -1,   -1,   -1,  318,  319,  320,
  321,  322,  323,   -1,   -1,   -1,  327,   -1,  329,  261,
  331,   -1,  333,  334,  335,   -1,   -1,  338,  339,  340,
   -1,  342,  343,  344,  345,  346,  347,  279,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,
  302,   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,
  312,  313,  314,   -1,   -1,   -1,  318,  319,  320,  321,
  322,  323,   -1,   -1,   -1,  327,   -1,  329,  261,  331,
   -1,  333,  334,  335,   -1,   -1,  338,  339,  340,   -1,
  342,  343,  344,  345,  346,  347,  279,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,
   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,
  313,  314,   -1,   -1,  261,  318,  319,  320,  321,  322,
  323,   -1,   -1,   -1,  327,  272,  329,   -1,  331,   -1,
  333,  334,  335,   -1,   -1,  338,  339,  340,   -1,  342,
  343,  344,  345,  346,  347,  292,  293,   -1,   -1,   -1,
  297,   -1,  299,   -1,  301,  302,   -1,  304,  305,   -1,
   -1,   -1,   -1,   -1,   -1,  312,  313,  314,   -1,   -1,
  261,  318,  319,  320,  321,  322,  323,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,  333,  334,  335,   -1,
   -1,  338,  339,  340,   -1,  342,  343,  344,  345,  346,
  347,  292,  293,   -1,   -1,   -1,  297,   -1,  299,   -1,
  301,  302,   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,  312,  313,  314,   -1,   -1,  261,  318,  319,  320,
  321,  322,  323,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,  333,  334,  335,   -1,   -1,  338,  339,  340,
   -1,  342,  343,  344,  345,  346,  347,  292,  293,   -1,
   -1,   -1,  297,   -1,  299,   -1,  301,  302,   -1,  304,
  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,
   -1,   -1,  261,  318,  319,  320,  321,  322,  323,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,  333,  334,
  335,   -1,   -1,  338,  339,  340,   -1,  342,  343,  344,
  345,  346,  347,  292,  293,   -1,   -1,   -1,  297,   -1,
  299,   -1,  301,  302,   -1,  304,  305,   -1,   -1,   -1,
   -1,   -1,   -1,  312,  313,  314,   -1,   -1,  261,  318,
  319,  320,  321,  322,  323,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,  333,  334,  335,   -1,   -1,  338,
  339,  340,   -1,  342,  343,  344,  345,  346,  347,  292,
  293,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,  302,
   -1,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,
  313,   -1,   -1,   -1,   -1,  318,  319,  320,  321,  322,
  323,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
  333,  334,  335,   -1,   -1,  338,  339,  340,   -1,  342,
  343,  344,  345,  346,  347,  293,   -1,   -1,   -1,   -1,
   -1,  299,   -1,  301,  302,  293,   -1,  305,   -1,   -1,
  308,  299,   -1,  301,  312,   -1,  304,   -1,   -1,   -1,
   -1,   -1,  320,  321,  312,  323,  314,  315,  293,  327,
   -1,  329,  320,  331,   -1,  333,  301,  302,  326,  327,
   -1,  329,  340,  331,   -1,   -1,   -1,  312,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 358
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"HEADER_KEY","HEADER_VAL",
"HEADER_END","BOGUS","SYMBOL","KEYWORD","SYMBOL_LITERAL","SHARP_T","SHARP_F",
"STRING","CHARACTER","INTEGER","FLOAT","BINARY_OPERATOR","LPAREN","RPAREN",
"COMMA","DOT","SEMI","LBRACKET","RBRACKET","LBRACE","RBRACE","COLON_COLON",
"MINUS","TILDE","EQUAL","EQUAL_EQUAL","ARROW","SHARP_PAREN","SHARP_BRACKET",
"NEXT","REST","KEY","ALL_KEYS","ABOVE","ABSTRACT","DBEGIN","BELOW","BLOCK","BY",
"CASE","CLASS","CLEANUP","CONCRETE","CONSTANT","DEFINE","DOMAIN",
"EACH_SUBCLASS","ELSE","ELSEIF","END","EXCEPTION","FINALLY","FOR","FREE","FROM",
"FUNCTION","GENERIC","HANDLER","IF","IN","INHERITED","INLINE","INSTANCE",
"KEYED_BY","KEYWORD_RESERVED_WORD","LET","LOCAL","METHOD","OPEN","OTHERWISE",
"PRIMARY","REQUIRED","SEALED","SELECT","SLOT","THEN","TO","UNLESS","UNTIL",
"USING","VARIABLE","VIRTUAL","WHILE","MODULE","LIBRARY","EXPORT","CREATE","USE",
"ALL","PREFIX_KEYWORD","IMPORT_KEYWORD","EXCLUDE_KEYWORD","EXPORT_KEYWORD",
"RENAME_KEYWORD","UNTIL_KEYWORD","WHILE_KEYWORD","FEATURE_IF","FEATURE_ELSE_IF",
"FEATURE_ELSE","FEATURE_ENDIF",
};
char *yyrule[] = {
"$accept : dylan_file",
"dylan_file : dylan_headers dylan_program",
"dylan_headers : HEADER_END",
"dylan_headers : header_list HEADER_END",
"header_list : HEADER_KEY HEADER_VAL",
"header_list : header_list HEADER_KEY HEADER_VAL",
"$$1 :",
"dylan_program : $$1 body",
"body : constituents semi_opt",
"body_opt :",
"body_opt : body",
"constituents : constituent",
"constituents : constituents SEMI constituent",
"constituent : defining_form",
"constituent : local_declaration",
"constituent : expression",
"constituent : error",
"defining_form : DEFINE flags CLASS class_definition",
"defining_form : DEFINE CONSTANT bindings",
"defining_form : DEFINE flags DOMAIN sealed_domain",
"defining_form : DEFINE flags GENERIC generic_function_definition",
"defining_form : DEFINE flags FUNCTION named_function",
"defining_form : DEFINE flags METHOD named_method",
"defining_form : DEFINE VARIABLE bindings",
"defining_form : DEFINE MODULE module_definition",
"defining_form : DEFINE LIBRARY library_definition",
"flags :",
"flags : flags SEALED",
"flags : flags OPEN",
"flags : flags ABSTRACT",
"flags : flags CONCRETE",
"flags : flags PRIMARY",
"flags : flags FREE",
"flags : flags INLINE",
"local_declaration : LET bindings",
"local_declaration : LET HANDLER variable_name EQUAL expression",
"local_declaration : LET HANDLER LPAREN expression property_list_opt RPAREN EQUAL expression",
"local_declaration : LOCAL local_methods",
"bindings : variable EQUAL expression",
"bindings : LPAREN variables RPAREN EQUAL expression",
"variables : rest_parameter",
"variables : variable",
"variables : variable COMMA variables",
"variable : variable_name",
"variable : variable_name COLON_COLON operand",
"variable_name : any_variable_name_except_function",
"variable_name : FUNCTION",
"any_variable_name_except_function : SYMBOL",
"any_variable_name_except_function : ABOVE",
"any_variable_name_except_function : ABSTRACT",
"any_variable_name_except_function : BY",
"any_variable_name_except_function : CLASS",
"any_variable_name_except_function : CONCRETE",
"any_variable_name_except_function : CONSTANT",
"any_variable_name_except_function : DOMAIN",
"any_variable_name_except_function : EACH_SUBCLASS",
"any_variable_name_except_function : FREE",
"any_variable_name_except_function : FROM",
"any_variable_name_except_function : IN",
"any_variable_name_except_function : INHERITED",
"any_variable_name_except_function : INLINE",
"any_variable_name_except_function : INSTANCE",
"any_variable_name_except_function : KEYED_BY",
"any_variable_name_except_function : KEYWORD_RESERVED_WORD",
"any_variable_name_except_function : OPEN",
"any_variable_name_except_function : PRIMARY",
"any_variable_name_except_function : SEALED",
"any_variable_name_except_function : SLOT",
"any_variable_name_except_function : THEN",
"any_variable_name_except_function : TO",
"any_variable_name_except_function : USING",
"any_variable_name_except_function : VARIABLE",
"any_variable_name_except_function : VIRTUAL",
"any_variable_name_except_function : MODULE",
"any_variable_name_except_function : LIBRARY",
"any_variable_name_except_function : EXPORT",
"any_variable_name_except_function : CREATE",
"any_variable_name_except_function : USE",
"any_variable_name_except_function : ALL",
"local_methods : local_method",
"local_methods : local_methods COMMA local_method",
"local_method : method_opt named_method",
"keyword : KEYWORD",
"keyword : PREFIX_KEYWORD",
"keyword : IMPORT_KEYWORD",
"keyword : EXCLUDE_KEYWORD",
"keyword : EXPORT_KEYWORD",
"keyword : RENAME_KEYWORD",
"keyword : UNTIL_KEYWORD",
"keyword : WHILE_KEYWORD",
"expression : keyword",
"expression : operand",
"expression : operand binop_series",
"binop_series : binop operand",
"binop_series : binop_series binop operand",
"binop : BINARY_OPERATOR",
"binop : MINUS",
"binop : EQUAL",
"binop : EQUAL_EQUAL",
"operand : MINUS operand",
"operand : TILDE operand",
"operand : leaf",
"leaf : constant",
"leaf : variable_name",
"leaf : leaf LBRACKET arguments_opt RBRACKET",
"leaf : leaf LPAREN arguments_opt RPAREN",
"leaf : anonymous_method",
"leaf : leaf DOT variable_name",
"leaf : LPAREN expression RPAREN",
"leaf : statement",
"arguments_opt :",
"arguments_opt : arguments",
"arguments : argument",
"arguments : arguments COMMA argument",
"argument : expression",
"argument : keyword expression",
"constant : SHARP_T",
"constant : SHARP_F",
"constant : concat_string",
"constant : CHARACTER",
"constant : INTEGER",
"constant : FLOAT",
"constant : SYMBOL_LITERAL",
"constant : SHARP_PAREN dotted_list RPAREN",
"constant : SHARP_PAREN literals_opt RPAREN",
"constant : SHARP_BRACKET literals_opt RBRACKET",
"concat_string : STRING",
"concat_string : concat_string STRING",
"dotted_list : literals DOT literal",
"literals_opt :",
"literals_opt : literals",
"literals : literal",
"literals : literals COMMA literal",
"literal : constant",
"literal : keyword",
"$$2 :",
"statement : DBEGIN $$2 body_opt END",
"$$3 :",
"statement : BLOCK LPAREN variable_name_opt RPAREN $$3 body block_epilog_opt END block_opt",
"$$4 :",
"statement : CASE $$4 condition_body END case_opt",
"$$5 :",
"statement : IF LPAREN expression RPAREN $$5 body else_part_opt END if_opt",
"$$6 :",
"statement : FOR LPAREN for_header RPAREN $$6 body_opt final_part_opt END for_opt",
"$$7 :",
"statement : SELECT LPAREN expression by_part_opt RPAREN $$7 condition_body END select_opt",
"$$8 :",
"statement : UNLESS LPAREN expression RPAREN $$8 body END unless_opt",
"$$9 :",
"statement : UNTIL LPAREN expression RPAREN $$9 body_opt END until_opt",
"$$10 :",
"statement : WHILE LPAREN expression RPAREN $$10 body_opt END while_opt",
"block_epilog_opt :",
"block_epilog_opt : block_epilog",
"block_epilog : exception_clauses_opt cleanup_part exception_clauses_opt",
"block_epilog : exception_clauses",
"condition_body : complete_condition_clauses",
"for_header : UNTIL expression",
"for_header : UNTIL_KEYWORD expression",
"for_header : WHILE expression",
"for_header : WHILE_KEYWORD expression",
"for_header : for_clause",
"for_header : for_clause COMMA for_header",
"exception_clauses_opt :",
"exception_clauses_opt : exception_clauses",
"exception_clauses : exception_clause",
"exception_clauses : exception_clauses exception_clause",
"exception_clause : EXCEPTION variable_name body",
"exception_clause : EXCEPTION LPAREN expression property_list_opt RPAREN body",
"exception_clause : EXCEPTION LPAREN variable_name COLON_COLON expression property_list_opt RPAREN body",
"complete_condition_clauses : OTHERWISE arrow_opt body",
"complete_condition_clauses : condition_clause semi_opt",
"complete_condition_clauses : condition_clause SEMI complete_condition_clauses",
"complete_condition_clauses : condition_clause SEMI incomplete_condition_clauses",
"incomplete_condition_clauses : constituent semi_opt",
"incomplete_condition_clauses : constituent SEMI complete_condition_clauses",
"incomplete_condition_clauses : constituent SEMI incomplete_condition_clauses",
"condition_clause : expression ARROW constituent",
"condition_clause : expression COMMA condition_clause",
"for_clause : variable EQUAL expression THEN expression",
"for_clause : LPAREN variables RPAREN EQUAL expression THEN expression",
"for_clause : variable IN expression",
"for_clause : variable KEYED_BY variable IN expression",
"for_clause : variable IN expression USING variable",
"for_clause : variable KEYED_BY variable IN expression USING variable",
"for_clause : variable FROM expression to_part_opt by_part_opt",
"by_part : BY expression",
"cleanup_part : CLEANUP body",
"final_part : FINALLY body",
"else_part : ELSE body",
"else_part : ELSEIF LPAREN expression RPAREN body else_part_opt",
"to_part_opt :",
"to_part_opt : TO expression",
"to_part_opt : ABOVE expression",
"to_part_opt : BELOW expression",
"class_definition : variable_name LPAREN superclasses RPAREN class_guts_opt END class_opt symbol_opt",
"superclasses : expression",
"superclasses : superclasses COMMA expression",
"class_guts_opt :",
"class_guts_opt : class_guts semi_opt",
"class_guts : slot_spec",
"class_guts : initarg_spec",
"class_guts : inherited_spec",
"class_guts : class_guts SEMI slot_spec",
"class_guts : class_guts SEMI initarg_spec",
"class_guts : class_guts SEMI inherited_spec",
"slot_spec : slot_adjectives allocation SLOT variable_name slot_type_opt slot_init_expr_opt property_list_opt",
"slot_adjectives :",
"slot_adjectives : flags SEALED",
"slot_adjectives : flags CONSTANT",
"slot_init_expr_opt :",
"slot_init_expr_opt : EQUAL expression",
"slot_type_opt :",
"slot_type_opt : COLON_COLON operand",
"initarg_spec : required_opt KEYWORD_RESERVED_WORD KEYWORD property_list_opt",
"required_opt : REQUIRED",
"required_opt :",
"inherited_spec : INHERITED SLOT variable_name slot_init_expr_opt property_list_opt",
"allocation :",
"allocation : INSTANCE",
"allocation : CLASS",
"allocation : EACH_SUBCLASS",
"allocation : VIRTUAL",
"property_list_opt :",
"property_list_opt : property_list",
"property_list : COMMA keyword expression",
"property_list : property_list COMMA keyword expression",
"sealed_domain : variable_name LPAREN arguments_opt RPAREN",
"generic_function_definition : variable_name LPAREN gf_parameters RPAREN gf_suffix",
"gf_suffix : property_list_opt",
"gf_suffix : ARROW return_type_element property_list_opt",
"gf_suffix : ARROW LPAREN return_type_list RPAREN property_list_opt",
"gf_parameters :",
"gf_parameters : positional_parameter more_gf_parameters",
"gf_parameters : gf_rest_parameters",
"more_gf_parameters :",
"more_gf_parameters : COMMA positional_parameter more_gf_parameters",
"more_gf_parameters : COMMA gf_rest_parameters",
"gf_rest_parameters : rest_parameter",
"gf_rest_parameters : rest_parameter COMMA gf_keyword_parameters_list",
"gf_rest_parameters : gf_keyword_parameters_list",
"gf_keyword_parameters_list : KEY gf_keyword_parameters_opt",
"gf_keyword_parameters_opt :",
"gf_keyword_parameters_opt : COMMA ALL_KEYS",
"gf_keyword_parameters_opt : gf_keyword_parameters",
"gf_keyword_parameters : gf_keyword_parameter",
"gf_keyword_parameters : gf_keyword_parameter COMMA ALL_KEYS",
"gf_keyword_parameters : gf_keyword_parameter COMMA gf_keyword_parameters",
"gf_keyword_parameter : keyword variable_name_opt keyword_parameter_type",
"gf_keyword_parameter : variable_name keyword_parameter_type",
"anonymous_method : METHOD method_description END method_opt",
"named_function : variable_name method_description END FUNCTION FUNCTION",
"named_function : variable_name method_description END function_opt any_variable_name_except_function_opt",
"named_method : variable_name method_description END method_opt variable_name_opt",
"method_description : LPAREN parameters RPAREN return_type body",
"method_description : LPAREN parameters RPAREN return_type",
"method_description : LPAREN parameters RPAREN semi_opt body_opt",
"return_type : ARROW return_type_list SEMI",
"return_type : ARROW LPAREN return_type_list RPAREN semi_opt",
"return_type_list :",
"return_type_list : REST return_type_element",
"return_type_list : return_type_list_head",
"return_type_list : return_type_list_head COMMA REST return_type_element",
"return_type_list_head : return_type_element",
"return_type_list_head : return_type_list_head COMMA return_type_element",
"return_type_element : variable_name",
"return_type_element : variable_name COLON_COLON expression",
"parameters :",
"parameters : positional_parameter more_parameters",
"parameters : next_parameters",
"more_parameters :",
"more_parameters : COMMA positional_parameter more_parameters",
"more_parameters : COMMA next_parameters",
"positional_parameter : variable_name",
"positional_parameter : variable_name COLON_COLON expression",
"positional_parameter : variable_name EQUAL_EQUAL expression",
"next_parameters : next_parameter",
"next_parameters : next_parameter COMMA rest_parameters",
"next_parameters : rest_parameters",
"next_parameter : NEXT variable_name",
"rest_parameters : rest_parameter",
"rest_parameters : rest_parameter COMMA keyword_parameters_list",
"rest_parameters : keyword_parameters_list",
"rest_parameter : REST variable_name",
"keyword_parameters_list : KEY keyword_parameters_opt",
"keyword_parameters_opt :",
"keyword_parameters_opt : COMMA ALL_KEYS",
"keyword_parameters_opt : keyword_parameters",
"keyword_parameters : keyword_parameter",
"keyword_parameters : keyword_parameter COMMA ALL_KEYS",
"keyword_parameters : keyword_parameter COMMA keyword_parameters",
"keyword_parameter : keyword_opt variable_name keyword_parameter_type keyword_parameter_default",
"keyword_parameter : keyword_opt variable_name LPAREN expression RPAREN",
"keyword_opt :",
"keyword_opt : keyword",
"keyword_parameter_type :",
"keyword_parameter_type : COLON_COLON operand",
"keyword_parameter_default :",
"keyword_parameter_default : EQUAL expression",
"module_definition : variable_name module_clauses_opt END module_opt symbol_opt",
"module_opt :",
"module_opt : MODULE",
"module_clauses_opt :",
"module_clauses_opt : module_clauses",
"module_clauses_opt : module_clauses SEMI",
"module_clauses : use_clause",
"module_clauses : export_clause",
"module_clauses : create_clause",
"module_clauses : module_clauses SEMI use_clause",
"module_clauses : module_clauses SEMI export_clause",
"module_clauses : module_clauses SEMI create_clause",
"export_clause : EXPORT variable_names",
"create_clause : CREATE variable_names",
"use_clause : USE variable_name module_use_options",
"module_use_options :",
"module_use_options : module_use_options COMMA module_use_option",
"module_use_option : prefix_option",
"module_use_option : import_option",
"module_use_option : exclude_option",
"module_use_option : rename_option",
"module_use_option : export_option",
"prefix_option : PREFIX_KEYWORD STRING",
"import_option : IMPORT_KEYWORD ALL",
"import_option : IMPORT_KEYWORD LBRACE imports_opt RBRACE",
"imports_opt :",
"imports_opt : imports",
"imports : variable_name",
"imports : variable_name ARROW variable_name",
"imports : imports COMMA variable_name",
"imports : imports COMMA variable_name ARROW variable_name",
"exclude_option : EXCLUDE_KEYWORD variable_name_set",
"export_option : EXPORT_KEYWORD ALL",
"export_option : EXPORT_KEYWORD variable_name_set",
"rename_option : RENAME_KEYWORD LBRACE RBRACE",
"rename_option : RENAME_KEYWORD LBRACE rename_specs RBRACE",
"rename_specs : variable_name ARROW variable_name",
"rename_specs : rename_specs COMMA variable_name ARROW variable_name",
"variable_name_set : LBRACE RBRACE",
"variable_name_set : LBRACE variable_names RBRACE",
"variable_names : variable_name",
"variable_names : variable_names COMMA variable_name",
"library_definition : variable_name library_clauses_opt END library_opt symbol_opt",
"library_opt :",
"library_opt : LIBRARY",
"library_clauses_opt :",
"library_clauses_opt : library_clauses",
"library_clauses_opt : library_clauses SEMI",
"library_clauses : use_clause",
"library_clauses : export_clause",
"library_clauses : library_clauses SEMI use_clause",
"library_clauses : library_clauses SEMI export_clause",
"block_opt :",
"block_opt : BLOCK",
"case_opt :",
"case_opt : CASE",
"if_opt :",
"if_opt : IF",
"for_opt :",
"for_opt : FOR",
"select_opt :",
"select_opt : SELECT",
"unless_opt :",
"unless_opt : UNLESS",
"until_opt :",
"until_opt : UNTIL",
"while_opt :",
"while_opt : WHILE",
"class_opt :",
"class_opt : CLASS",
"function_opt :",
"function_opt : FUNCTION",
"method_opt :",
"method_opt : METHOD",
"semi_opt :",
"semi_opt : SEMI",
"arrow_opt :",
"arrow_opt : ARROW",
"symbol_opt :",
"symbol_opt : SYMBOL",
"variable_name_opt :",
"variable_name_opt : variable_name",
"any_variable_name_except_function_opt :",
"any_variable_name_except_function_opt : any_variable_name_except_function",
"by_part_opt :",
"by_part_opt : by_part",
"else_part_opt :",
"else_part_opt : else_part",
"final_part_opt :",
"final_part_opt : final_part",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1302 "parser.y"

static void yyerror(char *msg)
{
    if (yylval.token)
	error(yylval.token->line, "%s at or before `%s'\n",
	      msg, yylval.token->chars);
    else
	error(line_count, "%s at end-of-file\n", msg);
    yacc_recover();
}

static boolean verify_symbol_aux(struct id *id, struct token *token)
{
    if (token) {
	int line = token->line;
	char *ptr = (char *)token->chars;

	if (*ptr == '\\')
	    ptr++;

	if (strcasecmp((char *)id->symbol->name, ptr)) {
	    error(line, "mismatched name, ``%s'' isn't ``%s''",
		  token->chars, id->symbol->name);
	    free(token);
	    return TRUE;
	}
	else
	    free(token);
    }
    return FALSE;
}

static void yacc_recover()
{
    while (yychar) {
	struct token_list *rlist = yacc_recovery_list;
	while (rlist)
	    if (rlist->token == yychar)
		return;
	    else
		rlist = rlist->next;
	yychar = yylex();
    }
    yyclearin;
}

static void push_yacc_recovery(int token)
{
    struct token_list *newrec;

    newrec = malloc(sizeof(*newrec));
    newrec->token = token;
    newrec->next = yacc_recovery_list;
    yacc_recovery_list = newrec;
}

static void pop_yacc_recoveries(int count)
{
    for ( ; count-- > 0; )
	yacc_recovery_list = yacc_recovery_list->next;
}

struct token *make_token(char *ptr, int len)
{
    struct token *token = malloc(sizeof(struct token) 
				 + len + 1 - sizeof(token->chars));

    token->length = len;
    memcpy(token->chars, ptr, len);
    token->line = line_count;
    token->chars[len] = 0;

    return token;
}

#line 1755 "parser-tab.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 2:
#line 293 "parser.y"
{ process_header(NULL, NULL); free(yyvsp[0].token); }
break;
case 3:
#line 294 "parser.y"
{ process_header(NULL, NULL); free(yyvsp[0].token); }
break;
case 4:
#line 299 "parser.y"
{ process_header((char *)yyvsp[-1].token->chars, (char *)yyvsp[0].token->chars); free(yyvsp[-1].token); free(yyvsp[0].token); }
break;
case 5:
#line 301 "parser.y"
{ process_header((char *)yyvsp[-1].token->chars, (char *)yyvsp[0].token->chars); free(yyvsp[-1].token); free(yyvsp[0].token); }
break;
case 6:
#line 305 "parser.y"
{ push_yacc_recovery(SEMI); }
break;
case 7:
#line 306 "parser.y"
{ Program = yyvsp[0].body; yyval.nothing = NULL; }
break;
case 8:
#line 310 "parser.y"
{ yyval.body = yyvsp[-1].body; }
break;
case 9:
#line 314 "parser.y"
{ yyval.body = make_body(); }
break;
case 10:
#line 315 "parser.y"
{ yyval.body = yyvsp[0].body; }
break;
case 11:
#line 321 "parser.y"
{ yyval.body = add_constituent(make_body(), yyvsp[0].constituent); }
break;
case 12:
#line 323 "parser.y"
{ free(yyvsp[-1].token); yyval.body = add_constituent(yyvsp[-2].body, yyvsp[0].constituent); }
break;
case 13:
#line 327 "parser.y"
{ yyval.constituent = yyvsp[0].constituent; }
break;
case 14:
#line 328 "parser.y"
{ yyval.constituent = yyvsp[0].constituent; }
break;
case 15:
#line 329 "parser.y"
{ yyval.constituent = make_expr_constituent(yyvsp[0].expr); }
break;
case 16:
#line 330 "parser.y"
{ yyval.constituent = make_error_constituent(); }
break;
case 17:
#line 335 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.constituent = set_class_flags(yyvsp[-2].flags, yyvsp[0].constituent); }
break;
case 18:
#line 337 "parser.y"
{ free(yyvsp[-2].token); yyval.constituent = make_define_constant(yyvsp[-1].token->line, yyvsp[0].bindings); free(yyvsp[-1].token); }
break;
case 19:
#line 339 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.constituent = set_sealed_domain_flags(yyvsp[-2].flags, yyvsp[0].constituent); }
break;
case 20:
#line 341 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.constituent = set_generic_flags(yyvsp[-2].flags, yyvsp[0].constituent); }
break;
case 21:
#line 343 "parser.y"
{ free(yyvsp[-3].token); yyval.constituent = make_define_function(yyvsp[-1].token->line, yyvsp[0].method); free(yyvsp[-1].token); }
break;
case 22:
#line 345 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.constituent = make_define_method(yyvsp[-2].flags, yyvsp[0].method); }
break;
case 23:
#line 347 "parser.y"
{ free(yyvsp[-2].token); yyval.constituent = make_define_variable(yyvsp[-1].token->line, yyvsp[0].bindings); free(yyvsp[-1].token); }
break;
case 24:
#line 349 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[-1].token); yyval.constituent = yyvsp[0].constituent; }
break;
case 25:
#line 351 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[-1].token); yyval.constituent = yyvsp[0].constituent; }
break;
case 26:
#line 355 "parser.y"
{ yyval.flags = 0; }
break;
case 27:
#line 356 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_SEALED; }
break;
case 28:
#line 357 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_OPEN; }
break;
case 29:
#line 358 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_ABSTRACT; }
break;
case 30:
#line 359 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_CONCRETE; }
break;
case 31:
#line 360 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_PRIMARY; }
break;
case 32:
#line 361 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_FREE; }
break;
case 33:
#line 362 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags; /* ignore inline directive */ }
break;
case 34:
#line 367 "parser.y"
{ free(yyvsp[-1].token); yyval.constituent = make_let(yyvsp[0].bindings); }
break;
case 35:
#line 369 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-3].token); free(yyvsp[-1].token);
	  yyval.constituent = make_handler(make_varref(make_id(yyvsp[-2].token)), yyvsp[0].expr, NULL);
	}
break;
case 36:
#line 373 "parser.y"
{ free(yyvsp[-7].token); free(yyvsp[-6].token); free(yyvsp[-5].token); free(yyvsp[-2].token); free(yyvsp[-1].token);
	  yyval.constituent = make_handler(yyvsp[-4].expr, yyvsp[0].expr, yyvsp[-3].plist);
	}
break;
case 37:
#line 377 "parser.y"
{ free(yyvsp[-1].token); yyval.constituent = make_local_constituent(yyvsp[0].local_methods); }
break;
case 38:
#line 382 "parser.y"
{ free(yyvsp[-1].token); yyval.bindings = make_bindings(push_param(yyvsp[-2].param,make_param_list()), yyvsp[0].expr); }
break;
case 39:
#line 384 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-2].token); free(yyvsp[-1].token); yyval.bindings = make_bindings(yyvsp[-3].param_list, yyvsp[0].expr); }
break;
case 40:
#line 389 "parser.y"
{ yyval.param_list = set_rest_param(make_param_list(), yyvsp[0].id); }
break;
case 41:
#line 391 "parser.y"
{ yyval.param_list = push_param(yyvsp[0].param, make_param_list()); }
break;
case 42:
#line 393 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = push_param(yyvsp[-2].param, yyvsp[0].param_list); }
break;
case 43:
#line 397 "parser.y"
{ yyval.param = make_param(make_id(yyvsp[0].token), NULL); }
break;
case 44:
#line 399 "parser.y"
{ free(yyvsp[-1].token); yyval.param = make_param(make_id(yyvsp[-2].token), yyvsp[0].expr); }
break;
case 79:
#line 443 "parser.y"
{ yyval.local_methods = add_local_method(make_local_methods(), yyvsp[0].method); }
break;
case 80:
#line 445 "parser.y"
{ free(yyvsp[-1].token); yyval.local_methods = add_local_method(yyvsp[-2].local_methods, yyvsp[0].method); }
break;
case 81:
#line 449 "parser.y"
{ yyval.method = yyvsp[0].method; }
break;
case 90:
#line 464 "parser.y"
{ yyval.expr = make_literal_ref(parse_keyword_token(yyvsp[0].token)); }
break;
case 91:
#line 465 "parser.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 92:
#line 467 "parser.y"
{ yyval.expr = make_binop_series_expr(yyvsp[-1].expr, yyvsp[0].binop_series); }
break;
case 93:
#line 471 "parser.y"
{ yyval.binop_series = add_binop(make_binop_series(), yyvsp[-1].binop, yyvsp[0].expr); }
break;
case 94:
#line 472 "parser.y"
{ yyval.binop_series = add_binop(yyvsp[-2].binop_series, yyvsp[-1].binop, yyvsp[0].expr); }
break;
case 95:
#line 476 "parser.y"
{ yyval.binop = make_binop(make_id(yyvsp[0].token)); }
break;
case 96:
#line 477 "parser.y"
{ yyval.binop = make_binop(make_id(yyvsp[0].token)); }
break;
case 97:
#line 478 "parser.y"
{ yyval.binop = make_binop(make_id(yyvsp[0].token)); }
break;
case 98:
#line 479 "parser.y"
{ yyval.binop = make_binop(make_id(yyvsp[0].token)); }
break;
case 99:
#line 483 "parser.y"
{ yyval.expr = make_negate(yyvsp[-1].token->line, yyvsp[0].expr); free(yyvsp[-1].token); }
break;
case 100:
#line 484 "parser.y"
{ yyval.expr = make_not(yyvsp[-1].token->line, yyvsp[0].expr); free(yyvsp[-1].token); }
break;
case 101:
#line 485 "parser.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 102:
#line 489 "parser.y"
{ yyval.expr = make_literal_ref(yyvsp[0].literal); }
break;
case 103:
#line 490 "parser.y"
{ yyval.expr = make_varref(make_id(yyvsp[0].token)); }
break;
case 104:
#line 492 "parser.y"
{ free(yyvsp[0].token); yyval.expr = make_aref_or_element(yyvsp[-2].token->line, yyvsp[-3].expr, yyvsp[-1].arglist); free(yyvsp[-2].token); }
break;
case 105:
#line 494 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[0].token); yyval.expr = make_function_call(yyvsp[-3].expr, yyvsp[-1].arglist); }
break;
case 106:
#line 495 "parser.y"
{ yyval.expr = make_method_ref(yyvsp[0].method); }
break;
case 107:
#line 497 "parser.y"
{ free(yyvsp[-1].token);
	  yyval.expr = make_dot_operation(yyvsp[-2].expr, make_varref(make_id(yyvsp[0].token)));
	}
break;
case 108:
#line 500 "parser.y"
{ yyval.expr = yyvsp[-1].expr; free(yyvsp[-2].token); free(yyvsp[0].token); }
break;
case 109:
#line 501 "parser.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 110:
#line 505 "parser.y"
{ yyval.arglist = make_argument_list(); }
break;
case 111:
#line 506 "parser.y"
{ yyval.arglist = yyvsp[0].arglist; }
break;
case 112:
#line 510 "parser.y"
{ yyval.arglist = add_argument(make_argument_list(), yyvsp[0].argument); }
break;
case 113:
#line 511 "parser.y"
{ free(yyvsp[-1].token); yyval.arglist = add_argument(yyvsp[-2].arglist, yyvsp[0].argument); }
break;
case 114:
#line 515 "parser.y"
{ yyval.argument = make_argument(yyvsp[0].expr); }
break;
case 115:
#line 517 "parser.y"
{ yyval.argument = make_keyword_argument(yyvsp[-1].token, yyvsp[0].expr); }
break;
case 116:
#line 521 "parser.y"
{ yyval.literal = parse_true_token(yyvsp[0].token); }
break;
case 117:
#line 522 "parser.y"
{ yyval.literal = parse_false_token(yyvsp[0].token); }
break;
case 118:
#line 523 "parser.y"
{ yyval.literal = yyvsp[0].literal; }
break;
case 119:
#line 524 "parser.y"
{ yyval.literal = parse_character_token(yyvsp[0].token); }
break;
case 120:
#line 525 "parser.y"
{ yyval.literal = parse_integer_token(yyvsp[0].token); }
break;
case 121:
#line 526 "parser.y"
{ yyval.literal = parse_float_token(yyvsp[0].token); }
break;
case 122:
#line 527 "parser.y"
{ yyval.literal = parse_keyword_token(yyvsp[0].token); }
break;
case 123:
#line 529 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[0].token); yyval.literal = yyvsp[-1].literal; }
break;
case 124:
#line 531 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[0].token); yyval.literal = make_list_literal(yyvsp[-1].literal_list); }
break;
case 125:
#line 533 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[0].token); yyval.literal = make_vector_literal(yyvsp[-1].literal_list); }
break;
case 126:
#line 537 "parser.y"
{ yyval.literal = parse_string_token(yyvsp[0].token); }
break;
case 127:
#line 538 "parser.y"
{ yyval.literal = concat_string_token(yyvsp[-1].literal, yyvsp[0].token); }
break;
case 128:
#line 542 "parser.y"
{ free(yyvsp[-1].token); yyval.literal = make_dotted_list_literal(yyvsp[-2].literal_list, yyvsp[0].literal); }
break;
case 129:
#line 547 "parser.y"
{ yyval.literal_list = make_literal_list(); }
break;
case 130:
#line 549 "parser.y"
{ yyval.literal_list = yyvsp[0].literal_list; }
break;
case 131:
#line 553 "parser.y"
{ yyval.literal_list = add_literal(make_literal_list(), yyvsp[0].literal); }
break;
case 132:
#line 555 "parser.y"
{ free(yyvsp[-1].token); yyval.literal_list = add_literal(yyvsp[-2].literal_list, yyvsp[0].literal); }
break;
case 133:
#line 559 "parser.y"
{ yyval.literal = yyvsp[0].literal; }
break;
case 134:
#line 560 "parser.y"
{ yyval.literal = parse_keyword_token(yyvsp[0].token); }
break;
case 135:
#line 564 "parser.y"
{ push_yacc_recovery(END); }
break;
case 136:
#line 566 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[0].token); yyval.expr = make_body_expr(yyvsp[-1].body);
          pop_yacc_recoveries(1); }
break;
case 137:
#line 569 "parser.y"
{ push_yacc_recovery(END);
	  push_yacc_recovery(CLEANUP);
	  push_yacc_recovery(EXCEPTION); }
break;
case 138:
#line 573 "parser.y"
{ free(yyvsp[-7].token); free(yyvsp[-5].token); free(yyvsp[-1].token); pop_yacc_recoveries(3); 
	  yyval.expr = make_block(yyvsp[-8].token->line, yyvsp[-6].token ? make_id(yyvsp[-6].token) : NULL, yyvsp[-3].body, yyvsp[-2].block_epilog);
	  free(yyvsp[-8].token);
	}
break;
case 139:
#line 577 "parser.y"
{ push_yacc_recovery(END); }
break;
case 140:
#line 579 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-1].token); yyval.expr = make_case(yyvsp[-2].condition_body);
          pop_yacc_recoveries(1); }
break;
case 141:
#line 581 "parser.y"
{ push_yacc_recovery(END);
				      push_yacc_recovery(ELSE); }
break;
case 142:
#line 584 "parser.y"
{ free(yyvsp[-8].token); free(yyvsp[-7].token); free(yyvsp[-5].token); free(yyvsp[-1].token); yyval.expr = make_if(yyvsp[-6].expr, yyvsp[-3].body, yyvsp[-2].else_part);
          pop_yacc_recoveries(2); }
break;
case 143:
#line 586 "parser.y"
{ push_yacc_recovery(END);
				       push_yacc_recovery(FINALLY); }
break;
case 144:
#line 589 "parser.y"
{ free(yyvsp[-8].token); free(yyvsp[-7].token); free(yyvsp[-5].token); free(yyvsp[-1].token); yyval.expr = make_for(yyvsp[-6].for_header, yyvsp[-3].body, yyvsp[-2].body);
          pop_yacc_recoveries(2); }
break;
case 145:
#line 591 "parser.y"
{push_yacc_recovery(END);}
break;
case 146:
#line 593 "parser.y"
{ free(yyvsp[-8].token);free(yyvsp[-7].token);free(yyvsp[-4].token);free(yyvsp[-1].token); yyval.expr = make_select(yyvsp[-6].expr, yyvsp[-5].expr, yyvsp[-2].condition_body);
          pop_yacc_recoveries(1); }
break;
case 147:
#line 595 "parser.y"
{ push_yacc_recovery(END); }
break;
case 148:
#line 597 "parser.y"
{ free(yyvsp[-7].token);free(yyvsp[-6].token);free(yyvsp[-4].token);free(yyvsp[-1].token);
	  yyval.expr = make_if(yyvsp[-5].expr, NULL, make_else(0, yyvsp[-2].body));
          pop_yacc_recoveries(1); }
break;
case 149:
#line 600 "parser.y"
{ push_yacc_recovery(END); }
break;
case 150:
#line 602 "parser.y"
{ free(yyvsp[-7].token);free(yyvsp[-6].token);free(yyvsp[-4].token);free(yyvsp[-1].token); pop_yacc_recoveries(1);
	  yyval.expr = make_for(make_for_header(yyvsp[-5].expr), yyvsp[-2].body, NULL);
	}
break;
case 151:
#line 605 "parser.y"
{ push_yacc_recovery(END); }
break;
case 152:
#line 607 "parser.y"
{ free(yyvsp[-6].token);free(yyvsp[-4].token);free(yyvsp[-1].token);pop_yacc_recoveries(1);
	  yyval.expr = make_for(make_for_header(make_not(yyvsp[-7].token->line, yyvsp[-5].expr)), yyvsp[-2].body, NULL);
	  free(yyvsp[-7].token);
	}
break;
case 153:
#line 614 "parser.y"
{ yyval.block_epilog = NULL; }
break;
case 154:
#line 615 "parser.y"
{ yyval.block_epilog = yyvsp[0].block_epilog; }
break;
case 155:
#line 620 "parser.y"
{ yyval.block_epilog = make_block_epilog(yyvsp[-2].exception_clauses, yyvsp[-1].body, yyvsp[0].exception_clauses); }
break;
case 156:
#line 622 "parser.y"
{ yyval.block_epilog = make_block_epilog(yyvsp[0].exception_clauses, NULL, NULL); }
break;
case 157:
#line 626 "parser.y"
{ yyval.condition_body = yyvsp[0].condition_body; }
break;
case 158:
#line 631 "parser.y"
{ warn(yyvsp[-1].token->line, "Use UNTIL: instead of UNTIL inside for loop");
	  free(yyvsp[-1].token); yyval.for_header = make_for_header(yyvsp[0].expr); }
break;
case 159:
#line 634 "parser.y"
{ free(yyvsp[-1].token); yyval.for_header = make_for_header(yyvsp[0].expr); }
break;
case 160:
#line 636 "parser.y"
{ warn(yyvsp[-1].token->line, "Use WHILE: instead of WHILE in for loop");
	  yyval.for_header = make_for_header(make_not(yyvsp[-1].token->line, yyvsp[0].expr)); free(yyvsp[-1].token); 
        }
break;
case 161:
#line 640 "parser.y"
{ yyval.for_header = make_for_header(make_not(yyvsp[-1].token->line, yyvsp[0].expr)); free(yyvsp[-1].token); }
break;
case 162:
#line 642 "parser.y"
{ yyval.for_header = push_for_clause(yyvsp[0].for_clause, make_for_header(NULL)); }
break;
case 163:
#line 644 "parser.y"
{ free(yyvsp[-1].token); yyval.for_header = push_for_clause(yyvsp[-2].for_clause, yyvsp[0].for_header); }
break;
case 164:
#line 648 "parser.y"
{ yyval.exception_clauses = NULL; }
break;
case 165:
#line 649 "parser.y"
{ yyval.exception_clauses = yyvsp[0].exception_clauses; }
break;
case 166:
#line 654 "parser.y"
{ yyval.exception_clauses = add_exception_clause(make_exception_clauses(), yyvsp[0].exception_clause); }
break;
case 167:
#line 656 "parser.y"
{ yyval.exception_clauses = add_exception_clause(yyvsp[-1].exception_clauses, yyvsp[0].exception_clause); }
break;
case 168:
#line 661 "parser.y"
{ 
	  warn(yyvsp[-2].token->line, "Token following EXCEPTION must be surrounded "
	       "by parentheses");
	  free(yyvsp[-2].token);
	  yyval.exception_clause = make_exception_clause(make_varref(make_id(yyvsp[-1].token)),
				     NULL, NULL, yyvsp[0].body);
	}
break;
case 169:
#line 669 "parser.y"
{ free(yyvsp[-5].token); free(yyvsp[-4].token); free(yyvsp[-1].token);
	  yyval.exception_clause = make_exception_clause(yyvsp[-3].expr, NULL, yyvsp[-2].plist, yyvsp[0].body);
	}
break;
case 170:
#line 674 "parser.y"
{ free(yyvsp[-7].token); free(yyvsp[-6].token); free(yyvsp[-4].token); free(yyvsp[-1].token);
	  yyval.exception_clause = make_exception_clause(yyvsp[-3].expr, make_id(yyvsp[-5].token), yyvsp[-2].plist, yyvsp[0].body);
	}
break;
case 171:
#line 681 "parser.y"
{ free(yyvsp[-2].token);
	  yyval.condition_body = push_condition_clause(make_otherwise_condition_clause(yyvsp[0].body),
				     NULL);
	}
break;
case 172:
#line 686 "parser.y"
{ yyval.condition_body = push_condition_clause(yyvsp[-1].condition_clause, NULL); }
break;
case 173:
#line 688 "parser.y"
{ free(yyvsp[-1].token); yyval.condition_body = push_condition_clause(yyvsp[-2].condition_clause, yyvsp[0].condition_body); }
break;
case 174:
#line 690 "parser.y"
{ free(yyvsp[-1].token); yyval.condition_body = complete_condition_clauses(yyvsp[-2].condition_clause, yyvsp[0].incomplete_condition_body); }
break;
case 175:
#line 695 "parser.y"
{ yyval.incomplete_condition_body = make_incomplete_condition_clauses(yyvsp[-1].constituent, NULL); }
break;
case 176:
#line 697 "parser.y"
{ free(yyvsp[-1].token); yyval.incomplete_condition_body = make_incomplete_condition_clauses(yyvsp[-2].constituent, yyvsp[0].condition_body); }
break;
case 177:
#line 699 "parser.y"
{ free(yyvsp[-1].token); yyval.incomplete_condition_body = push_condition_constituent(yyvsp[-2].constituent, yyvsp[0].incomplete_condition_body); }
break;
case 178:
#line 704 "parser.y"
{ free(yyvsp[-1].token); yyval.condition_clause = push_condition(yyvsp[-2].expr, make_condition_clause(yyvsp[0].constituent)); }
break;
case 179:
#line 706 "parser.y"
{ free(yyvsp[-1].token); yyval.condition_clause = push_condition(yyvsp[-2].expr, yyvsp[0].condition_clause); }
break;
case 180:
#line 711 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token);
	yyval.for_clause=make_equal_then_for_clause(push_param(yyvsp[-4].param,make_param_list()),yyvsp[-2].expr,yyvsp[0].expr);}
break;
case 181:
#line 714 "parser.y"
{ free(yyvsp[-6].token); free(yyvsp[-4].token); free(yyvsp[-3].token); free(yyvsp[-1].token);
	  yyval.for_clause = make_equal_then_for_clause(yyvsp[-5].param_list, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 182:
#line 717 "parser.y"
{ free(yyvsp[-1].token); yyval.for_clause = make_in_for_clause(yyvsp[-2].param, NULL, yyvsp[0].expr, NULL); }
break;
case 183:
#line 719 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.for_clause = make_in_for_clause(yyvsp[-4].param, yyvsp[-2].param, yyvsp[0].expr, NULL); }
break;
case 184:
#line 721 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.for_clause = make_in_for_clause(yyvsp[-4].param, NULL, yyvsp[-2].expr, yyvsp[0].param); }
break;
case 185:
#line 723 "parser.y"
{ free(yyvsp[-5].token); free(yyvsp[-3].token); yyval.for_clause = make_in_for_clause(yyvsp[-6].param, yyvsp[-4].param, yyvsp[-2].expr, yyvsp[0].param); }
break;
case 186:
#line 725 "parser.y"
{ free(yyvsp[-3].token); yyval.for_clause = make_from_for_clause(yyvsp[-4].param, yyvsp[-2].expr, yyvsp[-1].to_part, yyvsp[0].expr); }
break;
case 187:
#line 728 "parser.y"
{ free(yyvsp[-1].token); yyval.expr = yyvsp[0].expr; }
break;
case 188:
#line 729 "parser.y"
{ free(yyvsp[-1].token); yyval.body = yyvsp[0].body; }
break;
case 189:
#line 730 "parser.y"
{ free(yyvsp[-1].token); yyval.body = yyvsp[0].body; }
break;
case 190:
#line 733 "parser.y"
{ yyval.else_part = make_else(yyvsp[-1].token->line, yyvsp[0].body); free(yyvsp[-1].token); }
break;
case 191:
#line 735 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-2].token);
	  yyval.else_part = make_else(yyvsp[-5].token->line, make_expr_body(make_if(yyvsp[-3].expr, yyvsp[-1].body, yyvsp[0].else_part)));
	  free(yyvsp[-5].token); 
	}
break;
case 192:
#line 742 "parser.y"
{ yyval.to_part = NULL; }
break;
case 193:
#line 743 "parser.y"
{ free(yyvsp[-1].token); yyval.to_part = make_to(yyvsp[0].expr); }
break;
case 194:
#line 744 "parser.y"
{ free(yyvsp[-1].token); yyval.to_part = make_above(yyvsp[0].expr); }
break;
case 195:
#line 745 "parser.y"
{ free(yyvsp[-1].token); yyval.to_part = make_below(yyvsp[0].expr); }
break;
case 196:
#line 751 "parser.y"
{ struct id *id = make_id(yyvsp[-7].token);
	  verify_symbol(id, yyvsp[0].token); free(yyvsp[-6].token); free(yyvsp[-4].token); free(yyvsp[-2].token);
	  yyval.constituent = make_class_definition(id, yyvsp[-5].superclass_list, yyvsp[-3].class_guts);
	}
break;
case 197:
#line 759 "parser.y"
{ yyval.superclass_list = add_superclass(make_superclass_list(), yyvsp[0].expr); }
break;
case 198:
#line 761 "parser.y"
{ free(yyvsp[-1].token); yyval.superclass_list = add_superclass(yyvsp[-2].superclass_list, yyvsp[0].expr); }
break;
case 199:
#line 765 "parser.y"
{ yyval.class_guts = NULL; }
break;
case 200:
#line 766 "parser.y"
{ yyval.class_guts = yyvsp[-1].class_guts; }
break;
case 201:
#line 771 "parser.y"
{ yyval.class_guts = add_slot_spec(make_class_guts(), yyvsp[0].slot_spec); }
break;
case 202:
#line 773 "parser.y"
{ yyval.class_guts = add_initarg_spec(make_class_guts(), yyvsp[0].initarg_spec); }
break;
case 203:
#line 775 "parser.y"
{ yyval.class_guts = add_inherited_spec(make_class_guts(), yyvsp[0].inherited_spec); }
break;
case 204:
#line 777 "parser.y"
{ free(yyvsp[-1].token); yyval.class_guts = add_slot_spec(yyvsp[-2].class_guts, yyvsp[0].slot_spec); }
break;
case 205:
#line 779 "parser.y"
{ free(yyvsp[-1].token); yyval.class_guts = add_initarg_spec(yyvsp[-2].class_guts, yyvsp[0].initarg_spec); }
break;
case 206:
#line 781 "parser.y"
{ free(yyvsp[-1].token); yyval.class_guts = add_inherited_spec(yyvsp[-2].class_guts, yyvsp[0].inherited_spec); }
break;
case 207:
#line 787 "parser.y"
{
	    int line = yyvsp[-4].token->line;
	    free(yyvsp[-4].token);
	    yyval.slot_spec = make_slot_spec(line, yyvsp[-6].flags, yyvsp[-5].slot_allocation, yyvsp[-3].token ? make_id(yyvsp[-3].token) : NULL, 
				yyvsp[-2].expr, yyvsp[-1].expr, yyvsp[0].plist);
	}
break;
case 208:
#line 796 "parser.y"
{ yyval.flags = 0; }
break;
case 209:
#line 797 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_SEALED; }
break;
case 210:
#line 798 "parser.y"
{ free(yyvsp[0].token); yyval.flags = yyvsp[-1].flags | flag_CONSTANT; }
break;
case 211:
#line 802 "parser.y"
{ yyval.expr = NULL; }
break;
case 212:
#line 803 "parser.y"
{ free(yyvsp[-1].token); yyval.expr = yyvsp[0].expr; }
break;
case 213:
#line 807 "parser.y"
{ yyval.expr = NULL; }
break;
case 214:
#line 808 "parser.y"
{ free(yyvsp[-1].token); yyval.expr = yyvsp[0].expr; }
break;
case 215:
#line 813 "parser.y"
{ free(yyvsp[-2].token); yyval.initarg_spec = make_initarg_spec(yyvsp[-3].bool, yyvsp[-1].token, yyvsp[0].plist); }
break;
case 216:
#line 817 "parser.y"
{ free(yyvsp[0].token); yyval.bool = TRUE; }
break;
case 217:
#line 818 "parser.y"
{ yyval.bool = FALSE; }
break;
case 218:
#line 823 "parser.y"
{ 	    
	    int line = yyvsp[-2].token->line;
	    free(yyvsp[-4].token); free(yyvsp[-3].token); 
	    yyval.inherited_spec = make_inherited_spec(line, make_id(yyvsp[-2].token), yyvsp[-1].expr, yyvsp[0].plist); 
	}
break;
case 219:
#line 832 "parser.y"
{ yyval.slot_allocation = alloc_INSTANCE; }
break;
case 220:
#line 833 "parser.y"
{ free(yyvsp[0].token); yyval.slot_allocation = alloc_INSTANCE; }
break;
case 221:
#line 834 "parser.y"
{ free(yyvsp[0].token); yyval.slot_allocation = alloc_CLASS; }
break;
case 222:
#line 835 "parser.y"
{ free(yyvsp[0].token); yyval.slot_allocation = alloc_EACH_SUBCLASS; }
break;
case 223:
#line 836 "parser.y"
{ free(yyvsp[0].token); yyval.slot_allocation = alloc_VIRTUAL; }
break;
case 224:
#line 840 "parser.y"
{ yyval.plist = make_property_list(); }
break;
case 225:
#line 841 "parser.y"
{ yyval.plist = yyvsp[0].plist; }
break;
case 226:
#line 846 "parser.y"
{ free(yyvsp[-2].token); yyval.plist = add_property(make_property_list(), yyvsp[-1].token, yyvsp[0].expr); }
break;
case 227:
#line 848 "parser.y"
{ free(yyvsp[-2].token); yyval.plist = add_property(yyvsp[-3].plist, yyvsp[-1].token, yyvsp[0].expr); }
break;
case 228:
#line 853 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[0].token);
	  yyval.constituent = make_sealed_domain(make_id(yyvsp[-3].token), yyvsp[-1].arglist);
	}
break;
case 229:
#line 860 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token);
	  yyval.constituent = make_define_generic(make_id(yyvsp[-4].token), yyvsp[-2].param_list, yyvsp[0].gf_suffix);
	}
break;
case 230:
#line 867 "parser.y"
{ yyval.gf_suffix = make_gf_suffix(NULL, yyvsp[0].plist); }
break;
case 231:
#line 869 "parser.y"
{ free(yyvsp[-2].token);
	  yyval.gf_suffix = make_gf_suffix
	          (add_return_type(make_return_type_list(FALSE, NULL), yyvsp[-1].expr),
		   yyvsp[0].plist);
	}
break;
case 232:
#line 875 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.gf_suffix = make_gf_suffix(yyvsp[-2].return_type_list, yyvsp[0].plist); }
break;
case 233:
#line 879 "parser.y"
{ yyval.param_list = make_param_list(); }
break;
case 234:
#line 881 "parser.y"
{ yyval.param_list = push_param(yyvsp[-1].param, yyvsp[0].param_list); }
break;
case 235:
#line 882 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 236:
#line 887 "parser.y"
{ yyval.param_list = make_param_list(); }
break;
case 237:
#line 889 "parser.y"
{ free(yyvsp[-2].token); yyval.param_list = push_param(yyvsp[-1].param, yyvsp[0].param_list); }
break;
case 238:
#line 891 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = yyvsp[0].param_list; }
break;
case 239:
#line 896 "parser.y"
{ yyval.param_list = set_rest_param(make_param_list(), yyvsp[0].id); }
break;
case 240:
#line 898 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = set_rest_param(yyvsp[0].param_list, yyvsp[-2].id); }
break;
case 241:
#line 900 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 242:
#line 904 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = yyvsp[0].param_list; }
break;
case 243:
#line 908 "parser.y"
{ yyval.param_list = allow_keywords(make_param_list()); }
break;
case 244:
#line 910 "parser.y"
{ free(yyvsp[-1].token); free(yyvsp[0].token); yyval.param_list = allow_all_keywords(make_param_list()); }
break;
case 245:
#line 911 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 246:
#line 916 "parser.y"
{ yyval.param_list = push_keyword_param(yyvsp[0].keyword_param, allow_keywords(make_param_list())); }
break;
case 247:
#line 918 "parser.y"
{ free(yyvsp[-1].token); free(yyvsp[0].token);
	  yyval.param_list = push_keyword_param(yyvsp[-2].keyword_param, allow_all_keywords(make_param_list())); }
break;
case 248:
#line 921 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = push_keyword_param(yyvsp[-2].keyword_param, yyvsp[0].param_list); }
break;
case 249:
#line 926 "parser.y"
{ yyval.keyword_param = make_keyword_param(yyvsp[-2].token, yyvsp[-1].token ? make_id(yyvsp[-1].token) : NULL, yyvsp[0].expr, NULL); }
break;
case 250:
#line 928 "parser.y"
{ yyval.keyword_param = make_keyword_param(NULL, make_id(yyvsp[-1].token), yyvsp[0].expr, NULL); }
break;
case 251:
#line 933 "parser.y"
{ free(yyvsp[-1].token); yyval.method = set_method_source(yyvsp[-3].token, yyvsp[-2].method); }
break;
case 252:
#line 938 "parser.y"
{ struct id *id = make_id(yyvsp[-4].token);
	  free(yyvsp[-2].token); free(yyvsp[-1].token); verify_symbol(id, yyvsp[0].token);
	  yyval.method = set_method_name(id, yyvsp[-3].method);
	}
break;
case 253:
#line 943 "parser.y"
{ struct id *id = make_id(yyvsp[-4].token);
	  free(yyvsp[-2].token); verify_symbol(id, yyvsp[0].token);
	  yyval.method = set_method_name(id, yyvsp[-3].method);
	}
break;
case 254:
#line 951 "parser.y"
{ struct id *id = make_id(yyvsp[-4].token);
	  free(yyvsp[-2].token); verify_symbol(id, yyvsp[0].token);
	  yyval.method = set_method_name(id, yyvsp[-3].method);
	}
break;
case 255:
#line 959 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-2].token);
	  yyval.method = make_method_description(yyvsp[-3].param_list, yyvsp[-1].return_type_list, yyvsp[0].body);
	}
break;
case 256:
#line 963 "parser.y"
{ free(yyvsp[-3].token); free(yyvsp[-1].token);
	  yyval.method = make_method_description(yyvsp[-2].param_list, yyvsp[0].return_type_list, make_body());
	}
break;
case 257:
#line 967 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-2].token);
	  yyval.method = make_method_description(yyvsp[-3].param_list, NULL, yyvsp[0].body);
	}
break;
case 258:
#line 974 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[0].token); yyval.return_type_list = yyvsp[-1].return_type_list; }
break;
case 259:
#line 976 "parser.y"
{ free(yyvsp[-4].token); free(yyvsp[-3].token); free(yyvsp[-1].token); yyval.return_type_list = yyvsp[-2].return_type_list; }
break;
case 260:
#line 981 "parser.y"
{ yyval.return_type_list = make_return_type_list(FALSE, NULL); }
break;
case 261:
#line 983 "parser.y"
{ free(yyvsp[-1].token); yyval.return_type_list = make_return_type_list(TRUE, yyvsp[0].expr); }
break;
case 262:
#line 985 "parser.y"
{ yyval.return_type_list = yyvsp[0].return_type_list; }
break;
case 263:
#line 987 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[-1].token); yyval.return_type_list = set_return_type_rest_type(yyvsp[-3].return_type_list, yyvsp[0].expr); }
break;
case 264:
#line 992 "parser.y"
{ yyval.return_type_list = add_return_type(make_return_type_list(FALSE, NULL), yyvsp[0].expr); }
break;
case 265:
#line 994 "parser.y"
{ free(yyvsp[-1].token); yyval.return_type_list = add_return_type(yyvsp[-2].return_type_list, yyvsp[0].expr); }
break;
case 266:
#line 999 "parser.y"
{ warn(yyvsp[0].token->line, "Return value has name but no type");
	  free(yyvsp[0].token); yyval.expr = NULL; }
break;
case 267:
#line 1001 "parser.y"
{ free(yyvsp[-2].token); free(yyvsp[-1].token); yyval.expr = yyvsp[0].expr; }
break;
case 268:
#line 1005 "parser.y"
{ yyval.param_list = make_param_list(); }
break;
case 269:
#line 1006 "parser.y"
{ yyval.param_list = push_param(yyvsp[-1].param, yyvsp[0].param_list); }
break;
case 270:
#line 1007 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 271:
#line 1012 "parser.y"
{ yyval.param_list = make_param_list(); }
break;
case 272:
#line 1014 "parser.y"
{ free(yyvsp[-2].token); yyval.param_list = push_param(yyvsp[-1].param, yyvsp[0].param_list); }
break;
case 273:
#line 1016 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = yyvsp[0].param_list; }
break;
case 274:
#line 1021 "parser.y"
{ yyval.param = make_param(make_id(yyvsp[0].token), NULL); }
break;
case 275:
#line 1023 "parser.y"
{ free(yyvsp[-1].token); yyval.param = make_param(make_id(yyvsp[-2].token), yyvsp[0].expr); }
break;
case 276:
#line 1025 "parser.y"
{ yyval.param = make_param(make_id(yyvsp[-2].token), make_singleton(yyvsp[-1].token->line, yyvsp[0].expr));
	  free(yyvsp[-1].token); }
break;
case 277:
#line 1031 "parser.y"
{ yyval.param_list = set_next_param(make_param_list(), yyvsp[0].id); }
break;
case 278:
#line 1033 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = set_next_param(yyvsp[0].param_list, yyvsp[-2].id); }
break;
case 279:
#line 1035 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 280:
#line 1039 "parser.y"
{ free(yyvsp[-1].token); yyval.id = make_id(yyvsp[0].token); }
break;
case 281:
#line 1044 "parser.y"
{ yyval.param_list = set_rest_param(make_param_list(), yyvsp[0].id); }
break;
case 282:
#line 1046 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = set_rest_param(yyvsp[0].param_list, yyvsp[-2].id); }
break;
case 283:
#line 1048 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 284:
#line 1052 "parser.y"
{ free(yyvsp[-1].token); yyval.id = make_id(yyvsp[0].token); }
break;
case 285:
#line 1057 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = yyvsp[0].param_list; }
break;
case 286:
#line 1061 "parser.y"
{ yyval.param_list = allow_keywords(make_param_list()); }
break;
case 287:
#line 1063 "parser.y"
{ free(yyvsp[-1].token); free(yyvsp[0].token); yyval.param_list = allow_all_keywords(make_param_list()); }
break;
case 288:
#line 1064 "parser.y"
{ yyval.param_list = yyvsp[0].param_list; }
break;
case 289:
#line 1069 "parser.y"
{ yyval.param_list = push_keyword_param(yyvsp[0].keyword_param, allow_keywords(make_param_list())); }
break;
case 290:
#line 1071 "parser.y"
{ free(yyvsp[-1].token); free(yyvsp[0].token);
	  yyval.param_list = push_keyword_param(yyvsp[-2].keyword_param, allow_all_keywords(make_param_list())); }
break;
case 291:
#line 1074 "parser.y"
{ free(yyvsp[-1].token); yyval.param_list = push_keyword_param(yyvsp[-2].keyword_param, yyvsp[0].param_list); }
break;
case 292:
#line 1080 "parser.y"
{ yyval.keyword_param = make_keyword_param(yyvsp[-3].token, make_id(yyvsp[-2].token), yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 293:
#line 1082 "parser.y"
{ warn(yyvsp[-3].token->line,
	       "``foo (val)'' keyword default syntax obsolete.  "
	       "Use ``foo = val'' instead.");
	  free(yyvsp[-2].token); free(yyvsp[0].token);
	  yyval.keyword_param = make_keyword_param(yyvsp[-4].token, make_id(yyvsp[-3].token), NULL, yyvsp[-1].expr); }
break;
case 294:
#line 1090 "parser.y"
{ yyval.token = NULL; }
break;
case 295:
#line 1091 "parser.y"
{ yyval.token = yyvsp[0].token; }
break;
case 296:
#line 1095 "parser.y"
{ yyval.expr = NULL; }
break;
case 297:
#line 1096 "parser.y"
{ free(yyvsp[-1].token); yyval.expr = yyvsp[0].expr; }
break;
case 298:
#line 1100 "parser.y"
{ yyval.expr = NULL; }
break;
case 299:
#line 1101 "parser.y"
{ free(yyvsp[-1].token); yyval.expr = yyvsp[0].expr; }
break;
case 300:
#line 1106 "parser.y"
{ if (yyvsp[0].token) {
	      if (strcasecmp((char *)yyvsp[-4].token->chars, (char *)yyvsp[0].token->chars) != 0) {
		  error(yyvsp[0].token->line, "mismatched name, ``%s'' isn't ``%s''",
			yyvsp[0].token->chars, yyvsp[-4].token->chars);
		  yacc_recover();
	      }
	      free(yyvsp[0].token);
	  } 
	  free(yyvsp[-2].token);
	  yyval.constituent = (struct constituent *) set_namespace_name(yyvsp[-3].defnamespace_constituent, yyvsp[-4].token);
	}
break;
case 301:
#line 1120 "parser.y"
{ yyval.nothing = NULL; }
break;
case 302:
#line 1121 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 303:
#line 1124 "parser.y"
{ yyval.defnamespace_constituent = make_define_module(); }
break;
case 305:
#line 1126 "parser.y"
{ yyval.defnamespace_constituent = yyvsp[-1].defnamespace_constituent; free(yyvsp[0].token); }
break;
case 306:
#line 1131 "parser.y"
{ yyval.defnamespace_constituent = add_use_clause(make_define_module(), yyvsp[0].use_clause); }
break;
case 307:
#line 1133 "parser.y"
{ yyval.defnamespace_constituent = add_exports(make_define_module(), yyvsp[0].variable_names); }
break;
case 308:
#line 1135 "parser.y"
{ yyval.defnamespace_constituent = add_creates(make_define_module(), yyvsp[0].variable_names); }
break;
case 309:
#line 1137 "parser.y"
{ yyval.defnamespace_constituent = add_use_clause(yyvsp[-2].defnamespace_constituent, yyvsp[0].use_clause); free(yyvsp[-1].token); }
break;
case 310:
#line 1139 "parser.y"
{ yyval.defnamespace_constituent = add_exports(yyvsp[-2].defnamespace_constituent, yyvsp[0].variable_names); free(yyvsp[-1].token); }
break;
case 311:
#line 1141 "parser.y"
{ yyval.defnamespace_constituent = add_creates(yyvsp[-2].defnamespace_constituent, yyvsp[0].variable_names); free(yyvsp[-1].token); }
break;
case 312:
#line 1145 "parser.y"
{ free(yyvsp[-1].token); yyval.variable_names = yyvsp[0].variable_names; }
break;
case 313:
#line 1149 "parser.y"
{ free(yyvsp[-1].token); yyval.variable_names = yyvsp[0].variable_names; }
break;
case 314:
#line 1154 "parser.y"
{ free(yyvsp[-2].token); yyval.use_clause = make_use_clause(yyvsp[-1].token, yyvsp[0].use_options); }
break;
case 315:
#line 1158 "parser.y"
{ yyval.use_options = make_use_options(); }
break;
case 316:
#line 1160 "parser.y"
{ free(yyvsp[-1].token); yyval.use_options = add_use_option(yyvsp[-2].use_options, yyvsp[0].use_option); }
break;
case 322:
#line 1173 "parser.y"
{ yyval.use_option = make_prefix_option(yyvsp[0].token); free(yyvsp[-1].token); }
break;
case 323:
#line 1178 "parser.y"
{ yyval.use_option = make_use_option(useopt_IMPORT_ALL); free(yyvsp[-1].token); free(yyvsp[0].token); }
break;
case 324:
#line 1180 "parser.y"
{ yyval.use_option = (struct use_option *) yyvsp[-1].import_option; free(yyvsp[-3].token); free(yyvsp[-2].token); free(yyvsp[0].token); }
break;
case 325:
#line 1184 "parser.y"
{ yyval.import_option = make_import_option(); }
break;
case 326:
#line 1185 "parser.y"
{ yyval.import_option = yyvsp[0].import_option; }
break;
case 327:
#line 1190 "parser.y"
{ yyval.import_option = add_import(make_import_option(), yyvsp[0].token, NULL); }
break;
case 328:
#line 1192 "parser.y"
{ yyval.import_option = add_import(make_import_option(), yyvsp[-2].token, yyvsp[0].token); free(yyvsp[-1].token); }
break;
case 329:
#line 1194 "parser.y"
{ yyval.import_option = add_import(yyvsp[-2].import_option, yyvsp[0].token, NULL); free(yyvsp[-1].token); }
break;
case 330:
#line 1196 "parser.y"
{ yyval.import_option = add_import(yyvsp[-4].import_option, yyvsp[-2].token, yyvsp[0].token); free(yyvsp[-3].token); free(yyvsp[-1].token); }
break;
case 331:
#line 1201 "parser.y"
{ yyval.use_option = make_exclude_option(yyvsp[0].variable_names); free(yyvsp[-1].token); }
break;
case 332:
#line 1206 "parser.y"
{ yyval.use_option = make_use_option(useopt_EXPORT_ALL); free(yyvsp[-1].token); free(yyvsp[0].token); }
break;
case 333:
#line 1208 "parser.y"
{ yyval.use_option = make_export_option(yyvsp[0].variable_names); free(yyvsp[-1].token); }
break;
case 334:
#line 1213 "parser.y"
{ yyval.use_option = make_rename_option(make_renamings());
	  free(yyvsp[-2].token); free(yyvsp[-1].token); free(yyvsp[0].token); }
break;
case 335:
#line 1216 "parser.y"
{ yyval.use_option = make_rename_option(yyvsp[-1].renamings); free(yyvsp[-3].token); free(yyvsp[-2].token); free(yyvsp[0].token); }
break;
case 336:
#line 1221 "parser.y"
{ yyval.renamings = add_renaming(make_renamings(), yyvsp[-2].token, yyvsp[0].token); free(yyvsp[-1].token); }
break;
case 337:
#line 1223 "parser.y"
{ yyval.renamings = add_renaming(yyvsp[-4].renamings, yyvsp[-2].token, yyvsp[0].token); free(yyvsp[-3].token); free(yyvsp[-1].token); }
break;
case 338:
#line 1227 "parser.y"
{ yyval.variable_names = make_variable_names(); free(yyvsp[-1].token); free(yyvsp[0].token); }
break;
case 339:
#line 1229 "parser.y"
{ yyval.variable_names = yyvsp[-1].variable_names; free(yyvsp[-2].token); free(yyvsp[0].token); }
break;
case 340:
#line 1234 "parser.y"
{ yyval.variable_names = add_variable_name(make_variable_names(), yyvsp[0].token); }
break;
case 341:
#line 1236 "parser.y"
{ yyval.variable_names = add_variable_name(yyvsp[-2].variable_names, yyvsp[0].token); free(yyvsp[-1].token); }
break;
case 342:
#line 1241 "parser.y"
{ if (yyvsp[0].token) {
	      if (strcasecmp((char *)yyvsp[-4].token->chars, (char *)yyvsp[0].token->chars) != 0) {
		  error(yyvsp[0].token->line, "mismatched name, ``%s'' isn't ``%s''",
			yyvsp[0].token->chars, yyvsp[-4].token->chars);
		  yacc_recover();
	      }
	      free(yyvsp[0].token);
	  } 
	  free(yyvsp[-2].token);
	  yyval.constituent = (struct constituent *) set_namespace_name(yyvsp[-3].defnamespace_constituent, yyvsp[-4].token);
	}
break;
case 343:
#line 1255 "parser.y"
{ yyval.nothing = NULL; }
break;
case 344:
#line 1256 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 345:
#line 1259 "parser.y"
{ yyval.defnamespace_constituent = make_define_library(); }
break;
case 347:
#line 1261 "parser.y"
{ yyval.defnamespace_constituent = yyvsp[-1].defnamespace_constituent; free(yyvsp[0].token); }
break;
case 348:
#line 1266 "parser.y"
{ yyval.defnamespace_constituent = add_use_clause(make_define_library(), yyvsp[0].use_clause); }
break;
case 349:
#line 1268 "parser.y"
{ yyval.defnamespace_constituent = add_exports(make_define_library(), yyvsp[0].variable_names); }
break;
case 350:
#line 1270 "parser.y"
{ yyval.defnamespace_constituent = add_use_clause(yyvsp[-2].defnamespace_constituent, yyvsp[0].use_clause); free(yyvsp[-1].token); }
break;
case 351:
#line 1272 "parser.y"
{ yyval.defnamespace_constituent = add_exports(yyvsp[-2].defnamespace_constituent, yyvsp[0].variable_names); free(yyvsp[-1].token); }
break;
case 352:
#line 1276 "parser.y"
{ yyval.nothing = NULL; }
break;
case 353:
#line 1276 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 354:
#line 1277 "parser.y"
{ yyval.nothing = NULL; }
break;
case 355:
#line 1277 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 356:
#line 1278 "parser.y"
{ yyval.nothing = NULL; }
break;
case 357:
#line 1278 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 358:
#line 1279 "parser.y"
{ yyval.nothing = NULL; }
break;
case 359:
#line 1279 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 360:
#line 1280 "parser.y"
{ yyval.nothing = NULL; }
break;
case 361:
#line 1280 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 362:
#line 1281 "parser.y"
{ yyval.nothing = NULL; }
break;
case 363:
#line 1281 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 364:
#line 1282 "parser.y"
{ yyval.nothing = NULL; }
break;
case 365:
#line 1282 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 366:
#line 1283 "parser.y"
{ yyval.nothing = NULL; }
break;
case 367:
#line 1283 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 368:
#line 1284 "parser.y"
{ yyval.nothing = NULL; }
break;
case 369:
#line 1284 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 370:
#line 1285 "parser.y"
{ yyval.nothing = NULL; }
break;
case 371:
#line 1285 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 372:
#line 1286 "parser.y"
{ yyval.nothing = NULL; }
break;
case 373:
#line 1286 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 374:
#line 1287 "parser.y"
{ yyval.nothing = NULL; }
break;
case 375:
#line 1287 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 376:
#line 1288 "parser.y"
{ yyval.nothing = NULL; }
break;
case 377:
#line 1288 "parser.y"
{ free(yyvsp[0].token); yyval.nothing = NULL; }
break;
case 378:
#line 1290 "parser.y"
{ yyval.token = NULL; }
break;
case 379:
#line 1290 "parser.y"
{ yyval.token = yyvsp[0].token; }
break;
case 380:
#line 1291 "parser.y"
{ yyval.token = NULL; }
break;
case 381:
#line 1291 "parser.y"
{ yyval.token = yyvsp[0].token; }
break;
case 382:
#line 1293 "parser.y"
{ yyval.token = NULL; }
break;
case 383:
#line 1294 "parser.y"
{ yyval.token = yyvsp[0].token; }
break;
case 384:
#line 1297 "parser.y"
{ yyval.expr = NULL; }
break;
case 385:
#line 1297 "parser.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 386:
#line 1298 "parser.y"
{ yyval.else_part = NULL; }
break;
case 387:
#line 1298 "parser.y"
{ yyval.else_part = yyvsp[0].else_part; }
break;
case 388:
#line 1299 "parser.y"
{ yyval.body = NULL; }
break;
case 389:
#line 1299 "parser.y"
{ yyval.body = yyvsp[0].body; }
break;
#line 3361 "parser-tab.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
